function count = count_obs(index)
%count number of observations for each unique index

%assure that index is ordered
index = order_index(index);

fcn = @(x){ x(1:end) };
ind = accumarray(index, 1:numel(index), [max(index) 1], fcn);
sums = accumarray(index,1);
count = zeros(length(index),1);
for i = 1:length(sums)
    count(cell2mat(ind(i)),1) = sums(i,1);
end

end



function index = order_index(index)
%assures that index is ordered

index = [index zeros(length(index),1)];
index(2:end,2) = diff(index(:,1));
index(1,2) = 1;
index(:,2) = index(:,2)~=0;
index(:,1) = cumsum(index(:,2));
index(:,2) = [];

end