clear all
close all
clc

%%
%deterministic part of earnings over the life
addpath('F:\Insurance\Revision\Numerics\Clean\Stata')
A = importdata('profiles.out');

M(:,1) = A(1:40)';


life_determ.nodisab = smoothn(M(:,1),15);
life_determ.disab = A(41);

save('life_determ.mat','life_determ');

%% initial earnings distribution
A = importdata('earn_dist.out');
A=A(A(:,2)==25,1);
ini_dist = sort(A);
save('ini_dist.mat','ini_dist');


%% number of people in household 

A = importdata('hnp_dist.out');
A = A(A(:,1)==1,:);
hnp = smoothn(A(:,2),15);
save('hnp.mat','hnp');


%% transition to disability
M = csvread('age_dist.out');
names = {'id' 'weight' 'means_par' 'N' 'age' 'disab' 'wave' 'income'};
X = sortrows(M,5);

fcn = @(x)mean(x);
disable.rate = accumarray_expand_s(X(:,6),X(:,5),fcn);
disable.rate = disable.rate(1:40);
%make it wavely
disable.rate =interp1_l((1:3:120)',disable.rate,(1:1:120)');
disable.rate = smoothn(disable.rate,15);

%keep only those with length>1
M(:,9) = count_obs(M(:,1));
M(M(:,9)==1,:) = [];
M(:,9) = [];

%change in disability status by wave (1=got disabled, -1=got healthy)
X=M;
fcn = @(x){diff_indi(x,1)};
X(:,9) = accumarray_expand(X(:,6),X(:,1),fcn);
X(isnan(X(:,9)),:) = [];
X = sortrows(X,5);
X(:,9) = X(:,9)==-1;
fcn = @(x)mean(x);
disable.gethealth = accumarray_expand_s(X(:,9),X(:,5),fcn);
disable.gethealth = disable.gethealth(1:40);
disable.gethealth = smoothn(disable.gethealth(:,1),15);
disable.gethealth =interp1_l((1:3:120)',disable.gethealth,(1:1:120)');
disable.gethealth = smoothn(disable.gethealth,15);

for t = 1:119
    disable.getdisable(t,1) = (disable.rate(t+1,1)+disable.rate(t,1)*disable.gethealth(t,1)-disable.rate(t,1))./(1-disable.rate(t,1));
end
disable.getdisable = smoothn(disable.getdisable(:,1),15);

save('disable.mat','disable');

%% medical expenditure

A = importdata('hmed_exp.out');
life_health = smoothn(A(:,1),15);
save('life_health.mat','life_health');


%% share in DI

di_age = importdata('di_age.out');
di_age = smoothn(di_age(:,1),15);
save('di_age.mat','di_age');

%% income inequality
A = importdata('ineqal_inc.out');
var_inc_data = smoothn(A(1:40),15)';
var_inc_data = [var_inc_data; mean(A(42:86))];
save('var_inc_data.mat','var_inc_data');

%% consumption inequality
A = importdata('ineqal_cons.out');
var_cons_data = smoothn(A(1:40),15)';
var_cons_data = [var_cons_data; mean(A(42:86))];
save('var_cons_data.mat','var_cons_data');
