clear all
close all
clc
%compute life-cycle properties of earnings in unemployment

%% load data
addpath('F:\Insurance\Revision\Numerics\Clean\Stata')
M = csvread('unemp_determ.out');

names = {'id' 'time' 'educ' 'age' 'ub' 'earning' 'weight'};

%% average earnings over age

fcn = @(x)mean(x); 
M = sortrows(M,4);
earn_u.all(:,1) = accumarray_expand_s(M(:,6),M(:,4),fcn); 
earn_u.all(:,2) = accumarray_expand_s(M(:,5)+M(:,6),M(:,4),fcn); 


earn_u.all(:,1) = smoothn(earn_u.all(:,1),15);
earn_u.all(:,2) = smoothn(earn_u.all(:,2),15);



save('earn_u.mat','earn_u');

