#include "fintrf.h"

!----------------------------------------------------------------------------
! Gateway routine
!----------------------------------------------------------------------------

subroutine mexFunction(nlhs,plhs,nrhs,prhs)
    implicit none
    
    ! Arguments in mexFunction
      mwPointer  :: plhs(*), prhs(*)
      integer    :: nlhs, nrhs
    
    ! Function declarations
      mwPointer     mxCreateNumericArray ,mxGetPr, mxGetM, mxGetN
      mwPointer     mxGetDimensions, mxCreateDoubleMatrix
      integer(4)    mxClassIDFromClassName
      mwSize        mxGetNumberOfDimensions
      
      ! Pointers to input/output mxArrays:
      ! Input           
      mwPointer  :: EV,agrid,aprime,low_max,low_max2,abar,na,nap,I,phi,R,S,S2,gamma,health,hh_scale,hgrid &
                    ,nh,alpha,hbar,xi,stigma,abound,s_aprime

       ! Output
      mwPointer  :: V,policy_a,policy_h,policy_s
      
    ! Array size information
      integer(4)    :: complexFlag,classid                        ! length of input (output) array
      mwSize        :: ndim
      mwSize        :: dims(2)                    ! dimensions (for mxCreateNumericArray)

      
!--------------------------------------------------------------------------------    
      
      !size of input (and output) vector
      ndim = mxGetNumberOfDimensions(prhs(1))

      ! Retrieve size of input arguments (also size of output argument)
      call mxCopyPtrToPtrArray(mxGetDimensions(prhs(1)), dims, mxGetNumberOfDimensions(prhs(1)))
	  
      classid = mxClassIDFromClassName('double')
      complexFlag = 0  
      
      ! Retrieve input parameter pointers
      EV = mxGetPr(prhs(1))
      agrid = mxGetPr(prhs(2))
      aprime = mxGetPr(prhs(3))
      low_max = mxGetPr(prhs(4))
      low_max2 = mxGetPr(prhs(5))
      abar = mxGetPr(prhs(6))
      na = mxGetPr(prhs(7))
      nap = mxGetPr(prhs(8))
      I = mxGetPr(prhs(9))
      phi = mxGetPr(prhs(10))
      R = mxGetPr(prhs(11))
      S = mxGetPr(prhs(12))
      S2 = mxGetPr(prhs(13))
      gamma = mxGetPr(prhs(14))
	  health = mxGetPr(prhs(15))
	  hh_scale = mxGetPr(prhs(16))
      hgrid = mxGetPr(prhs(17))
      nh = mxGetPr(prhs(18))
      alpha = mxGetPr(prhs(19))
      hbar = mxGetPr(prhs(20))
      xi = mxGetPr(prhs(21))
      stigma = mxGetPr(prhs(22))
      abound = mxGetPr(prhs(23))
      s_aprime = mxGetPr(prhs(24))
     

     ! Create matrices for return arguments
        !V,policy,discon_out
      plhs(1) = mxCreateNumericArray(ndim, dims, classid, complexflag)
      plhs(2) = mxCreateNumericArray(ndim, dims, classid, complexflag)
	  plhs(3) = mxCreateNumericArray(ndim, dims, classid, complexflag)
      plhs(4) = mxCreateNumericArray(ndim, dims, classid, complexflag)
	  
      V = mxGetPr(plhs(1))
      policy_a = mxGetPr(plhs(2))
	  policy_h = mxGetPr(plhs(3))
      policy_s = mxGetPr(plhs(4))

      !call computation function
      call  sub_ind_work_test_exog(%val(V),%val(policy_a),%val(policy_h),%val(policy_s),%val(EV) &
	                              ,%val(agrid),%val(aprime),%val(low_max),%val(low_max2),%val(abar) &
                                  ,%val(na),%val(nap),%val(I),%val(phi),%val(R),%val(S),%val(S2) &
                                  ,%val(gamma),%val(health),%val(hh_scale),%val(hgrid),%val(nh) &
                                  ,%val(alpha),%val(hbar),%val(xi),%val(stigma),%val(abound) &
                                  ,%val(s_aprime))
        
      return  
      
end subroutine



subroutine sub_ind_work_test_exog(V,policy_a,policy_h,policy_s,EV,agrid,aprime,low_max,low_max2,abar,na,nap &
                                  ,I,phi,R,S,S2,gamma,health,hh_scale,hgrid,nh,alpha,hbar,xi,stigma,abound &
                                  ,s_aprime)

implicit none

integer(4), intent(in)					      :: na,nap,nh,low_max,low_max2
real(8), intent(in)					          :: abar,R,S,S2,gamma,phi,health,hh_scale,I,alpha,hbar
real(8), intent(in)					          :: xi,stigma
real(8), dimension(na), intent(in)			  :: agrid
real(8), dimension(nap), intent(in)			  :: aprime,s_aprime
integer(4), dimension(nap), intent(in)        :: abound
real(8), dimension(nh), intent(in)			  :: hgrid
real(8), dimension(na,nh), intent(in)         :: EV
real(8), dimension(na,nh), intent(out)        :: V,policy_a,policy_h,policy_s


!define further variables
real(8), dimension(nap,nh)              :: c,util,W,pol_s_aux
real(8), dimension(nap)                 :: v1
real(8)                                 :: util_aux,disutil,gamma_bar,resources,resources_t
real(8)                                 :: cS,utilS,stigmaS,contu
integer(4)				                :: i1,i2,i3,i4,i5,i6,i7,index_a,index_h(nap),index_b(2)
real(8), parameter                      :: minval = 1e-40
       


disutil = exp(phi)
stigmaS = exp(stigma)
gamma_bar = 1.d0-gamma
call pref(util_aux,minval,hgrid(1),hh_scale,gamma_bar,disutil,alpha,hbar,1.d0) !reservation utility

do i1=1,nh !loop over housing STATE
            
    do i2=1,na !loop over asset state

        
        do i3=1,nh !loop over house choice

            if (i3 == i1) then
                resources_t = R*agrid(i2)+I+S
                resources = R*agrid(i2)+(I-health)
            else
                resources_t = R*agrid(i2)+hgrid(i1)-hgrid(i3)+I+S-xi
                resources = R*agrid(i2)+hgrid(i1)-hgrid(i3)+(I-health)-xi
            end if
            
            if ((resources_t-aprime(1))<0.d0) then !no positive consumption possible
                W(1:nap,i3) = util_aux
            else
                
                i4 = 0
                do while (i4<low_max) !transfers

                    i4 = i4+1
                    c(i4,i3) = resources_t-aprime(i4)
                    cS = resources-aprime(i4)
                    if (c(i4,i3)<minval) then
                        util(i4:low_max,i3)=util_aux
                        W(i4:low_max,i3) = util(i4:low_max,i3)
                        i4 = low_max
                    else
                        if (cS<minval) then
                            call pref(util(i4,i3),c(i4,i3),hgrid(i1) &
                                ,hh_scale,gamma_bar,disutil,alpha,hbar,stigmaS) !utility level for stigma choice
                            pol_s_aux(i4,i3) = 0.d0
                        else
                            call pref(util(i4,i3),c(i4,i3),hgrid(i1) &
                                ,hh_scale,gamma_bar,disutil,alpha,hbar,stigmaS) !utility level for stigma choice
                            call pref(utilS,cS,hgrid(i1),hh_scale,gamma_bar,disutil,alpha,hbar,1.d0) !utility level for non stigma choice
                            if (utilS>util(i4,i3)) then
                                util(i4,i3) = utilS
                                pol_s_aux(i4,i3) = 1.d0
                            else
                                pol_s_aux(i4,i3) = 0.d0
                            end if
                        end if
                        call lininter2(agrid,EV(:,i3),na,abound(i4),s_aprime(i4),aprime(i4),contu)
                        W(i4,i3) = util(i4,i3)+contu
                    end if
                end do
                
                i4 = low_max
                do while (i4<low_max2) !transfers
                    i4 = i4+1
                    c(i4,i3) = resources+S2-aprime(i4)
                    if (c(i4,i3)<minval) then
                        util(i4:nap,i3)=util_aux
                        W(i4:nap,i3) = util(i4:nap,i3)
                        i4 = nap
                    else
                        call pref(util(i4,i3),c(i4,i3),hgrid(i1),hh_scale,gamma_bar,disutil,alpha,hbar,1.d0) 
                        call lininter2(agrid,EV(:,i3),na,abound(i4),s_aprime(i4),aprime(i4),contu)
                        W(i4,i3) = util(i4,i3)+contu
                    end if
                end do
                
                i4 = low_max2
                do while (i4<nap) !no transfers
                    i4 = i4+1
                    pol_s_aux(i4,i3) = 0.d0
                    c(i4,i3) = resources-aprime(i4)
                    if (c(i4,i3)<minval) then
                        util(i4:nap,i3)=util_aux
                        W(i4:nap,i3) = util(i4:nap,i3)
                        i4 = nap
                    else
                        call pref(util(i4,i3),c(i4,i3),hgrid(i1),hh_scale,gamma_bar,disutil,alpha,hbar,1.d0) 
                        call lininter2(agrid,EV(:,i3),na,abound(i4),s_aprime(i4),aprime(i4),contu)
                        W(i4,i3) = util(i4,i3)+contu
                    end if
                end do
        
            end if      
                
        end do

        
		!maximum over houses
        do i7 = 1,nap
            call max_val(v1(i7),index_h(i7),W(i7,:),nh)
        end do
        
        !maximum over assets
        call max_val(V(i2,i1),index_a,v1,nap)
        policy_a(i2,i1) = aprime(index_a)
        policy_h(i2,i1) = hgrid(index_h(index_a))
        policy_s(i2,i1) = pol_s_aux(index_a,index_h(index_a))


    end do
end do

end subroutine



subroutine pref(util,c,h,hh_scale,gamma,disutil,alpha,hbar,stigma)

!define in and outputs
real(8), intent(in)    :: c,h,hh_scale,gamma,disutil,alpha,hbar,stigma
real(8), intent(out)   :: util

!define further variables
real(8)                :: consu


consu = hh_scale*(((c*disutil*stigma)**(alpha))*((hbar+h)**(1-alpha)))

util = (consu**(gamma))/(gamma)


end subroutine



subroutine max_val(y,I,x,na)

!computes maximum (y) and index (I) of vector x, with length na.
!define in and outputs
integer(4), intent(in)	   :: na
real(8), intent(in)    :: x(na)
real(8), intent(out)    :: y
integer(4), intent(out)	   :: I

!define further variables
integer(4)				:: i1

y = x(1)
I = 1

do i1 = 2,na
	if (x(i1)>y) then
		y = x(i1)
		I = i1
	end if
end do

end subroutine


subroutine max_val2(y,II1,II2,x,n1,n2)

!computes maximum (y) and index (I1,I2) of matrix x, with dimension (n1,n2).
!define in and outputs
integer(4), intent(in)	                  :: n1,n2
real(8), dimension(n1,n2), intent(in)     :: x
real(8), intent(out)                      :: y
integer, intent(out)	                  :: II1,II2

!define further variables
integer(4)				                  :: i1,i2
integer(4), dimension(n2)                 :: i_aux
real(8), dimension(n2)                    :: y_aux

!find maximum for each column
do i2=1,n2
    y_aux(i2) = x(1,i2)
    i_aux(i2) = 1
    do i1 = 2,n1
	    if (x(i1,i2) > y_aux(i2)) then
		    y_aux(i2) = x(i1,i2)
		    i_aux(i2) = i1
	    end if
    end do
end do

!find maximum across columns
II2 = 1
y = y_aux(1)
do i2 = 2,n2
	if (y_aux(i2) > y) then
		y = y_aux(i2)
        II2 = i2
	end if
end do
II1 = i_aux(II2)


end subroutine
    
    
subroutine find_pos(vec_in,sca,pos,n)
!finds sca on monotone vector vec_in (number of smaller/equal points)

!define in and outputs
integer, intent(in)	   :: n
real(8), intent(in)    :: vec_in(n),sca
integer, intent(out)   :: pos
integer                :: i1

pos = 0
do i1 = 1,n
	if (sca>=vec_in(i1)) then
		pos = i1
	end if
	if (vec_in(i1)>sca) exit
end do

end subroutine




subroutine lininter(x,y,n,x0,y0)

!Function lininter computes a linear interpolation for point x0
!given the vector of x-values in x and their corresponding funtional values y with length n

implicit none

!define in and outputs
integer, intent(in)						:: n
real(8), intent(in)             		:: x(n),y(n)
real(8), intent(in)                     :: x0
real(8), intent(out)                    :: y0

!further variables 
integer                                 :: j

!call locate(x,n,x0,j)
call find_pos(x,x0,j,n)

if (j==0) then
    j=1
elseif (j==n) then
    j=n-1
end if

y0 = y(j)+(y(j+1)-y(j))*(x0-x(j))/(x(j+1)-x(j));

end subroutine lininter

    
subroutine lininter2(x,y,n,j,dist,x0,y0)

!Function lininter computes a linear interpolation for point x0
!given the vector of x-values in x and their corresponding funtional values y with length n

implicit none

!define in and outputs
integer, intent(in)						:: n,j
real(8), intent(in)             		:: x(n),y(n)
real(8), intent(in)                     :: x0,dist
real(8), intent(out)                    :: y0


y0 = y(j)+(y(j+1)-y(j))*dist

end subroutine lininter2
    


subroutine max_int(int_out,int1,int2)

!max of integer

implicit none

!define in and outputs
integer, intent(in)						:: int1,int2
integer, intent(out)                    :: int_out


if (int1>=int2) then
    int_out = int1
else
    int_out = int2
end if

end subroutine max_int


subroutine sub_mexWriteString(String)
  implicit none
  character(*),intent(in):: String
  call mexPrintf(achar(10))
  call mexPrintf(trim(adjustl(String)))
end subroutine sub_mexWriteString