function initial_asset = create_initial(agrid,na,tol)
%creates initial asset grid and assures that total assets are the same as
%in main routine.

load('dens_ini2.mat','dens_ini2');
load('grid_ini2.mat','grid_ini2');

[~,index] = histc(min(max(agrid),grid_ini2),agrid);
initial_asset = zeros(na,1);
for i = 1:length(index)
    initial_asset(index(i,1),1) = initial_asset(index(i,1),1)+dens_ini2(i,1);
end
initial_asset = initial_asset./sum(initial_asset);

%assure that total assets are equal to baseline
load('Result_f.mat','Result_f');
initial_asset_f = Result_f.initial_asset;
agrid_f = Result_f.agrid;
clear Result_f
initial_asset_f_total = sum(initial_asset_f.*agrid_f);
crit_asset = abs(sum(initial_asset.*agrid)-initial_asset_f_total);
asset_up = 0.001;
count = 0;

while crit_asset > tol.asset && count<100000
    count = count+1;
    if initial_asset_f_total>sum(initial_asset.*agrid) %in f are more total assets
        if initial_asset(1,1)>initial_asset_f(1,1) %more zero mass in alternative
            initial_old = initial_asset(1,1);
            initial_asset(1,1) = initial_old*(1-asset_up);
            initial_asset(2,1) = initial_asset(2,1)+initial_old*asset_up;
        else %move complete distribution
            initial_old = initial_asset(2:end);
            initial_asset(2:end-1,1) = initial_old(1:end-1)*(1-asset_up);
            initial_asset(3:end,1) = initial_asset(3:end)+initial_old(1:end-1)*asset_up;
%             index = find(initial_asset(2:end)>0,1,'first');
%             initial_old = initial_asset(index+1,1);
%             initial_asset(index+1,1) = initial_old*(1-asset_up);
%             initial_asset(index+2,1) = initial_asset(index+2,1)+initial_old*asset_up;
        end
    else %in alternative are more total asset
        if initial_asset_f(1,1)> initial_asset(1,1) %more zero mass in f
            index = find(initial_asset(2:end)>10^(-14),1,'first');
            initial_old = initial_asset(index+1,1);
            initial_asset(index+1,1) = initial_old*(1-asset_up);
            initial_asset(1,1) = initial_asset(1,1)+initial_old*asset_up;
        else %move entire distribution
            initial_old = initial_asset(2:end);
            initial_asset(3:end,1) = initial_old(2:end)*(1-asset_up);
            initial_asset(2:end-1,1) = initial_asset(2:end-1)+initial_old(2:end)*asset_up;
%             index = find(initial_asset(2:end)>0,2,'first');
%             index = index(end,1);
%             initial_old = initial_asset(index+1,1);
%             initial_asset(index+1,1) = initial_old*(1-asset_up);
%             initial_asset(index,1) = initial_asset(index,1)+initial_old*asset_up;
        end
    end
    initial_asset = initial_asset./sum(initial_asset);
    crit_asset = abs(sum(initial_asset.*agrid)-initial_asset_f_total);
    track(count,1) = sum(initial_asset.*agrid);
end

if count == 100000
    disp('No solution to initial assets found')
end

end