function [agrid,cut] = get_agrid(amin,amax,na,abar1,abar2,S,N,nc,work,retire,disable,R)
%function computes asset grid and index over which households receive no
%AMT benefits

agrid = (amin:300:abar2)'; 
agrid = [agrid; linspace(abar2+1000,15000,12)'];
agrid = [agrid; linspace(15000+3000,amax,na)'];

cut_old = 0; %guess cut


points = [1000; abar1; abar2; 5000; 10000; 16000]; %points I impose to be on the grid
points = sort(points);

%assure that points are on grid 
crit = 1;
while crit>0
    
    for i = 1:length(points)
        if sum(points(i,1)==agrid)==0 %point does not exist yet
            index = sum(points(i,1)>agrid);
            agrid = [agrid(1:index); points(i,1); agrid(index+1:end)]; %add the point to agrid
        end
    end
    
    if sum(abar1==agrid)==0
        disp('Problem with computing grid points')
    end
    if sum(abar2==agrid)==0
        disp('Problem with computing grid points')
    end
    cut(1) = find(abar1==agrid);
    cut(2) = find(abar2==agrid);
    
    crit = abs(cut_old-cut);
    cut_old = cut;
    
end


end