function [sim_initial_perm,born_prob,mean_log] = get_born(data,w,echoice_e,H,pmin,pmax)
%get initial distribution of productivities

logw = log(w);

%restrict data to productivity grid
wmin = exp(pmin);
wmax = exp(pmax);
data = max(wmin,min(sort(data),wmax));
data(:,2) = (1:length(data))/length(data);

%make data a probability distribution
rand('seed',355712);
sim_ini = rand(H,1);
for i = 1:H
    index = sum(sim_ini(i,1)>data(:,2))+1;
    sim_initial_perm(i,1) = log(data(index,1));
end

%this part is redundant
born_prob = zeros(size(w));
h = diff(w);
ny = length(born_prob);
[~,k] = histc(data,w);
k(data<w(1)) = 1; 
k(data>=w(end)) = ny-1;
s = (data - w(k))./h(k);
for i = 1:length(data)
    born_prob(k(i)) = born_prob(k(i))+s(i);
    born_prob(k(i)+1) = born_prob(k(i)+1)+1-s(i);
end
born_prob = born_prob./sum(born_prob); %make it a probability
mean_log = sum(born_prob.*logw);

end