function S = get_transfer(w,wd,w_retire,w_disab,w_u,b,N,nc,work,retire,disab,egl_w,egl_wd,egl_r,egl_rss,egl_d,egl_dss,egl_b,hh_size)
%computes AMT transfers

%load data
load('mt_other.mat','mt_other'); 
load('mt_other_R.mat','mt_other_R'); 
load('mt_wic.mat','mt_wic');
mt_other_U = mt_other;
mt_other_w = mt_other;
mt_wic_U = mt_wic;
mt_wic_w = mt_wic;


food_t = [111; 203; 292; 370]; %food transfers conditional on size
food_int = interp1_l([1;2;3;4],food_t,hh_size);
tanf_t = [0.772*366; 0.772*366; 366; 366*1.228]; %TANF transfers conditional on size (1 never occurs)
tanf_int = interp1_l([1;2;3;4],tanf_t,hh_size);

net_w_f = max(0,(w*0.8)-(4*122)); %net income after allowance for food stamps when working non-disabled
net_w_a = max(0,w-(120+w/3)); %net income after allowance for TANF stamps when working non-disabled
net_wd_f = max(0,(wd*0.8)-(4*122)); %net income after allowance for food stamps when working disabled
net_wd_a = max(0,wd-(120+w/3)); %net income after allowance for TANF stamps when working disabled
S.w = zeros(N,work); %total transfers when working non-disabled
S.w_d = zeros(N,work); %total transfers when working disabled
for t = 1:work
    food_aux = food_int(t);
    tanf_aux = tanf_int(t);
    for i = 1:N
        if egl_w(i,t)
            S.w(i,t) = mt_other_w;
            if t<=42 %add WIC
                S.w(i,t) = S.w(i,t)+mt_wic_w;
            end
            S.w(i,t) = S.w(i,t)+max(0,(food_aux*4)-(0.3*net_w_f(i,t))); %FOOD
                S.w(i,t) = S.w(i,t)+max(0,(tanf_aux*4)-net_w_a(i,t)); %TANF
        end
        
        if egl_wd(i,t)
            S.w_d(i,t) = mt_other_w;
            if t<=42 %add WIC
                S.w_d(i,t) = S.w_d(i,t)+mt_wic_w;
            end
            S.w_d(i,t) = S.w_d(i,t)+max(0,(food_aux*4)-(0.3*net_wd_f(i,t))); %FOOD
                S.w_d(i,t) = S.w_d(i,t)+max(0,(tanf_aux*4)-net_wd_a(i,t)); %TANF
        end
    end
end


net_u = max(0,((w_u))-(4*122));%net income after allowance for food stamps when non-employed 
net_u_a = max(0,(2/3*w_u)); %net income after allowance for TANF stamps when non-employed 
S.u = zeros(work,1); %total transfers when working non-employed 
for t = 1:work
    food_aux = food_int(t);
    tanf_aux = tanf_int(t);
    if egl_b(t,1)
        S.u(t) = mt_other_U;
        S.u(t) = S.u(t)+max(0,(food_aux*4)-(0.3*net_u(t,1))); %FOOD
            S.u(t) = S.u(t)+max(0,(tanf_aux*4)-net_u_a(t,1)); %TANF
        if t<=42 %add WIC
            S.u(t) = S.u(t)+mt_wic_U;
        end
    end
end


ssi_t = [422; 633; 633]; %ssi transfers conditional on size for disabled
ssi_int = interp1_l([1;2;3],ssi_t,hh_size);

d_r = 20*4; %allowance
net_ssi = max(0,(w_disab*0.5)-(d_r+65)); %net income after allowance for supplemental security income
S.d = zeros(nc,disab); %total transfers when DI recipient
for t = 1:disab
    food_aux = food_int(t+work-disab);
    ssi_aux = ssi_int(t+work-disab);
    for j = 1:nc
        if egl_dss(j,t) %eligible to supplemental security income
            ssi_inc_aux = max(0,((ssi_aux)*4)-net_ssi(j,t)); 
            net_d(j,t) = max(0,(w_disab(j,t)+ssi_inc_aux)-(4*122)); %net income for food stamps
            S.d(j,t) = mt_other_w;
            S.d(j,t) = S.d(j,t)+max(0,(food_aux*4)-(0.3*net_d(j,t))); %FOOD
            S.d(j,t) = S.d(j,t)+ssi_inc_aux; %SSI
        elseif egl_d(j,t)
            net_d(j,t) = max(0,(w_disab(j,t))-(4*122));
            S.d(j,t) = mt_other_w;
            S.d(j,t) = S.d(j,t)+max(0,(food_aux*4)-(0.3*net_d(j,t))); %FOOD
        end
    end
end


ssi_t = [422; 633; 633]; %ssi transfers conditional on size for retired
ssi_int = interp1_l([1;2;3],ssi_t,hh_size);


net_ssi = max(0,(w_retire*0.5)-(4*20)); %net income after allowance for supplemental security income
S.r = zeros(nc,retire); %total transfers when retired
for t = 1:retire
    food_aux = food_int(work+t);
    ssi_aux = ssi_int(work+t);
    for j = 1:nc
        if egl_rss(j,t)
            %SSI income
            ssi_inc_aux = max(0,((ssi_aux)*3)-net_ssi(j,t));
            net_r(j,t) = max(0,(w_retire(j,t)+ssi_inc_aux)-(4*122));
            S.r(j,t) = mt_other_R;
            S.r(j,t) = S.r(j,t)+max(0,(food_aux*4)-(0.3*net_r(j,t))); %FOOD
            S.r(j,t) = S.r(j,t)+ssi_inc_aux; %SSI
        elseif egl_r(j,t)
            net_r(j,t) = max(0,(w_retire(j,t))-(4*122));
            S.r(j,t) = mt_other_R;
            S.r(j,t) = S.r(j,t)+max(0,(food_aux*4)-(0.3*net_r(j,t))); %FOOD
        end
        
    end
end



end