function S = get_transfer_pow(w,wd,w_retire,w_disab,w_u,b,N,nc,work,retire,disab,egl_w,egl_wd,egl_r,egl_rss,egl_d,egl_dss,egl_b,hh_size)

%TANF benefits a household may receive

tanf_t = [0.772*366; 0.772*366; 366; 366*1.228]; %1 never occurs
tanf_int = interp1_l([1;2;3;4],tanf_t,hh_size);


net_w_a = max(0,w-(120+w/3));
net_wd_a = max(0,wd-(120+w/3));
S.w = zeros(N,work);
S.w_d = zeros(N,work);
for t = 1:work
    tanf_aux = tanf_int(t);
    for i = 1:N
        if egl_w(i,t)

                S.w(i,t) = S.w(i,t)+max(0,(tanf_aux*4)-net_w_a(i,t)); %TANF

        end
        
        if egl_wd(i,t)

                S.w_d(i,t) = S.w_d(i,t)+max(0,(tanf_aux*4)-net_wd_a(i,t)); %TANF

        end
    end
end


net_u_a = max(0,(2/3*w_u));
S.u = zeros(work,1); 
for t = 1:work
    tanf_aux = tanf_int(t);
    if egl_b(t,1)
            S.u(t) = S.u(t)+max(0,(tanf_aux*4)-net_u_a(t,1)); %TANF
    end
end


S.d = zeros(nc,disab);


S.r = zeros(nc,retire);



end