function panel = labor_supply(panel_in,... 
			L,work,disab,old,n2,na,nc,amax,R,amin,destruct_health,offer_health,destruct_disab,offer_disab,...
            born_prob,urate_ini,disab_ini,agrid,grid_nc,pgrid,pgrid_d,policy_a_e,...
            policy_a_u,policy_a_uj,policy_a_d,policy_a_r,policy_a_e_disab,policy_a_u_disab,policy_a_uj_disab,...
            emp_pol_e,emp_pol_u,emp_pol_e_disab,emp_pol_u_disab,emp_pol_e2,emp_pol_e2_disab,d_pol,d_pol_disab,S_w,...
            S_u,S_d,S_r,S_wd,w,ben,w_d,w_r,wd,wgross_r,wgross_d,wdgross,abar,abar2,survival,w_u,health,wgross,...
            egl_w,egl_b,egl_d,egl_r,egl_wd,psi,psi_d,mu1,mu2,delta1,delta2,disab_dis,pmin,pmax,prod_shock,hgrid,...
            nh,policy_h_e,policy_h_u,policy_h_uj,policy_h_d,policy_h_r,policy_h_e_disab,policy_h_u_disab,...
            policy_h_uj_disab,sim_destruct,sim_offer,sim_death,...
            sim_dis,sim_disab,sim_health,xi,d_cut,...
            tran_dh,tran_hd,policy_s_e,policy_s_u,policy_s_uj,policy_s_d,...
            policy_s_r,policy_s_e_disab,policy_s_u_disab,policy_s_uj_disab,ybarf_y,ybarf_o,ybarss)


panel = zeros(size(panel_in));        

for i1 = 1:L
    
    t1 = panel_in(i1,8);
    %productivity transition
    if (t1 <= (work-old))
        if (panel_in(i1,2) == 1 && panel_in(i1,15) == 0) %employed, non-disabled
            panel(i1,3) = min(pmax,max(pmin,panel_in(i1,3)+mu1+prod_shock(i1,1)-0.1));
            if (sim_health(i1,1)>tran_hd(t1))
                panel(i1,15)=0;
            else
                panel(i1,15)=1;
                panel(i1,3) = max(pmin,panel(i1,3)-disab_dis)
            end
        elseif (panel_in(i1,2) == 1 && panel_in(i1,15) == 1) %employed, disabled
            panel(i1,3) = min(pmax,max(pmin,panel_in(i1,3)+mu1+prod_shock(i1,1)-0.1));
            if (sim_health(i1,1)>tran_dh(t1))
                panel(i1,15)=1;
            else
                panel(i1,15)=0
                panel(i1,3) = min(pmax,panel(i1,3)+disab_dis);
            end
        elseif (panel_in(i1,2) > 0 && panel_in(i1,15) == 0) %unemployed, non-disabled
            panel(i1,3) = min(pmax,max(pmin,panel_in(i1,3)+delta1+prod_shock(i1,1)-0.1));
            if (sim_health(i1,1)>tran_hd(t1))
                panel(i1,15)=0;
            else
                panel(i1,15)=1;
                panel(i1,3) = max(pmin,panel(i1,3)-disab_dis);
            end
        elseif (panel_in(i1,2) > 0 && panel_in(i1,15) == 1) %unemployed, disabled
            panel(i1,3) = min(pmax,max(pmin,panel_in(i1,3)+delta1+prod_shock(i1,1)-0.1));
            if (sim_health(i1,1)>tran_dh(t1))
                panel(i1,15)=1;
            else
                panel(i1,15)=0;
                panel(i1,3) = min(pmax,panel(i1,3)+disab_dis)
            end
        end
    elseif (t1<=work)
        if (panel_in(i1,2) == 1 && panel_in(i1,15) == 0) %employed, non-disabled
            panel(i1,3) = min(pmax,max(pmin,panel_in(i1,3)+mu2+prod_shock(i1,1)-0.1));
            if (sim_health(i1,1)>tran_hd(t1))
                panel(i1,15)=0;
            else
                panel(i1,15)=1;
                panel(i1,3) = max(pmin,panel(i1,3)-disab_dis);
            end
        elseif (panel_in(i1,2) == 1 && panel_in(i1,15) == 1) %employed, disabled
            panel(i1,3) = min(pmax,max(pmin,panel_in(i1,3)+mu2+prod_shock(i1,1)-0.1));
            if (sim_health(i1,1)>tran_dh(t1))
                panel(i1,15)=1;
            else
                panel(i1,15)=0;
                panel(i1,3) = min(pmax,panel(i1,3)+disab_dis);
            end
        elseif (panel_in(i1,2) > 0 && panel_in(i1,15) == 0) %unemployed, non-disabled
            panel(i1,3) = min(pmax,max(pmin,panel_in(i1,3)+delta2+prod_shock(i1,1)-0.1));
            if (sim_health(i1,1)>tran_hd(t1))
                panel(i1,15)=0;
            else
                panel(i1,15)=1;
                panel(i1,3) = max(pmin,panel(i1,3)-disab_dis);
            end
        elseif (panel_in(i1,2) > 0 && panel_in(i1,15) == 1) %unemployed, disabled
            panel(i1,3) = min(pmax,max(pmin,panel_in(i1,3)+delta2+prod_shock(i1,1)-0.1));
            if (sim_health(i1,1)>tran_dh(t1))
                panel(i1,15)=1;
            else
                panel(i1,15)=0;
                panel(i1,3) = min(pmax,panel(i1,3)+disab_dis);
            end
        end
    end
    
    if (t1 < work)
        if (t1 <= (work-disab)) %cannot apply
            aux_h = sum(panel_in(i1,13)+1>hgrid);
            aux_h = min(nh,aux_h)
            aux_h = max(1,aux_h)
            if (panel_in(i1,2) == 1 && panel_in(i1,15) == 0) %employed, non-disabled
                w_t = lininter(pgrid,w(:,t1),panel_in(i1,3));
                w_gt = exp(panel_in(i1,3));
                panel(i1,4) = (panel_in(i1,4)*t1+w_gt)/(t1+1); %accumulated earnings
                aux_p = sum(panel_in(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel_in(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel_in(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                aux_ht = sum(h_dec+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                dist = abs(hgrid(aux_ht)-h_dec) %assure that h_dec is a discrete choice
                if (dist>10)
                    h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                    aux_ht = sum(h_dec+1>hgrid);
                    aux_ht = min(nh,aux_ht);
                    aux_ht = max(1,aux_ht);
                    dist = abs(hgrid(aux_ht)-h_dec); %assure that h_dec is a discrete choice
                    if (dist>10)
                        h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        aux_ht = sum(h_dec+1>hgrid);
                        aux_ht = min(nh,aux_ht);
                        aux_ht = max(1,aux_ht);
                        dist = abs(hgrid(aux_ht)-h_dec);
                        if (dist>10)
                            h_dec = policy_h_e(a_temp,aux_nc,aux_p,aux_h,t1)
                            aux_ht = sum(h_dec+1>hgrid);
                            aux_ht = min(nh,aux_ht);
                            aux_ht = max(1,aux_ht);
                            k_dec = policy_a_e(a_temp,aux_nc,aux_p,aux_h,t1);
                        else
                            k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        end
                    else
                        k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    end
                end
                
                if (w_gt<=ybarf_y(t1))
                    panel(i1,10) = 1;
                    if (k_dec>abar(t1) &&  k_dec<(abar(t1)+1000)) %possible extrapolation error
                        a_temp = sum(panel_in(i1,6)>agrid);
                        a_temp = max(a_temp,1);
                        a_temp = min(a_temp,na);
                        k_dec2=interp3_l(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),agrid(a_temp),grid_nc(aux_nc),panel(i1,3),a_temp,aux_nc,aux_p);
                        if (k_dec2<(abar(t1)+10))
                            k_dec = abar(t1);
                        end
                    end
                end
                panel(i1,6) = max(min(k_dec,amax),amin);
                panel(i1,13) = hgrid(aux_ht) %house transition
                
                aux_ht = sum(panel(i1,13)+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                aux_p = sum(panel(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                if (sim_destruct(i1,1)<=destruct_health(t1))
                    panel(i1,2) = 2;
                else
                    e_dec=interp3_l(agrid,grid_nc,pgrid,emp_pol_e(:,:,:,aux_ht,t1),panel(i1,6),panel(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    
                    if (e_dec<0.5)  %choose unemployment
                        panel(i1,2) = 2;
                    else
                        panel(i1,2) = 1;
                    end
                end
                
            elseif (panel_in(i1,2) == 1 && panel_in(i1,15) == 1) %employed, disabled
                
                w_t = lininter(pgrid,wd(:,t1),panel_in(i1,3));
                w_gt = exp(panel_in(i1,3));
                panel(i1,4) = (panel_in(i1,4)*t1+w_gt)/(t1+1); %accumulated earnings
                aux_p = sum(panel_in(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel_in(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel_in(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e_disab(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e_disab(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                aux_ht = sum(h_dec+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                dist = abs(hgrid(aux_ht)-h_dec) %assure that h_dec is a discrete choice
                if (dist>10)
                    h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                    aux_ht = sum(h_dec+1>hgrid);
                    aux_ht = min(nh,aux_ht);
                    aux_ht = max(1,aux_ht);
                    dist = abs(hgrid(aux_ht)-h_dec); %assure that h_dec is a discrete choice
                    if (dist>10)
                        h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        aux_ht = sum(h_dec+1>hgrid);
                        aux_ht = min(nh,aux_ht);
                        aux_ht = max(1,aux_ht);
                        dist = abs(hgrid(aux_ht)-h_dec);
                        if (dist>10)
                            h_dec = policy_h_e_disab(a_temp,aux_nc,aux_p,aux_h,t1)
                            aux_ht = sum(h_dec+1>hgrid);
                            aux_ht = min(nh,aux_ht);
                            aux_ht = max(1,aux_ht);
                            k_dec = policy_a_e_disab(a_temp,aux_nc,aux_p,aux_h,t1);
                        else
                            k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        end
                    else
                        k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    end
                end
                if (w_gt<=ybarf_y(t1))
                    if (k_dec>abar(t1) &&  k_dec<(abar(t1)+1000)) %possible extrapolation error
                        a_temp = sum(panel_in(i1,6)>agrid);
                        a_temp = max(a_temp,1);
                        a_temp = min(a_temp,na);
                        k_dec2=interp3_l(agrid,grid_nc,pgrid,policy_a_e_disab(:,:,:,aux_h,t1),agrid(a_temp),grid_nc(aux_nc),panel(i1,3),a_temp,aux_nc,aux_p);
                        if (k_dec2<(abar(t1)+10))
                            k_dec = abar(t1);
                        end
                    end
                end
                panel(i1,6) = max(min(k_dec,amax),amin);
                panel(i1,13) = hgrid(aux_ht) %house transition
                
                aux_ht = sum(panel(i1,13)+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                aux_p = sum(panel(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                if (sim_destruct(i1,1)<=destruct_disab(t1))
                    panel(i1,2) = 2;
                else
                    e_dec=interp3_l(agrid,grid_nc,pgrid,emp_pol_e_disab(:,:,:,aux_ht,t1),panel(i1,6),panel(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    
                    if (e_dec<0.5)  %choose unemployment
                        panel(i1,2) = 2;
                    else
                        panel(i1,2) = 1;
                    end
                end
                
            elseif (panel_in(i1,2) > 1 && panel_in(i1,15) == 0) %just unemployed or unemployed, non-disabled
                panel(i1,4) = (panel_in(i1,4)*t1)/(t1+1); %accumulated earnings
                aux_p = sum(panel_in(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel_in(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel_in(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                aux_ht = sum(h_dec+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                dist = abs(hgrid(aux_ht)-h_dec) %assure that h_dec is a discrete choice
                if (dist>10)
                    h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                    aux_ht = sum(h_dec+1>hgrid);
                    aux_ht = min(nh,aux_ht);
                    aux_ht = max(1,aux_ht);
                    dist = abs(hgrid(aux_ht)-h_dec); %assure that h_dec is a discrete choice
                    if (dist>10)
                        h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        aux_ht = sum(h_dec+1>hgrid);
                        aux_ht = min(nh,aux_ht);
                        aux_ht = max(1,aux_ht);
                        dist = abs(hgrid(aux_ht)-h_dec);
                        if (dist>10)
                            h_dec = policy_h_u(a_temp,aux_nc,aux_p,aux_h,t1)
                            aux_ht = sum(h_dec+1>hgrid);
                            aux_ht = min(nh,aux_ht);
                            aux_ht = max(1,aux_ht);
                            k_dec = policy_a_u(a_temp,aux_nc,aux_p,aux_h,t1);
                        else
                            k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        end
                    else
                        k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    end
                end
                
                aux_i_egl = floor(egl_b(t1))
                if (aux_i_egl==1)
                    if (k_dec>abar(t1) &&  k_dec<(abar(t1)+1000)) %possible extrapolation error
                        k_dec2=interp3_l(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),agrid(a_temp),grid_nc(aux_nc),panel(i1,3),a_temp,aux_nc,aux_p);
                        if (k_dec2<(abar(t1)+10))
                            k_dec = abar(t1);
                        end
                    end
                end
                panel(i1,6) = max(min(k_dec,amax),amin);  %asset transition
                panel(i1,13) = hgrid(aux_ht) %house transition
                
                aux_ht = sum(panel(i1,13)+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                aux_p = sum(panel(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                
                e_dec=interp3_l(agrid,grid_nc,pgrid,emp_pol_e_disab(:,:,:,aux_ht,t1),panel(i1,6),panel(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                if (e_dec<0.5)%out of labor force
                    panel(i1,2) = 3;
                else
                    if (sim_offer(i1,1)<=offer_health(t1)) %employment transitions
                        panel(i1,2) = 1;
                    else
                        panel(i1,2) = 3;
                    end
                end
                
            elseif (panel_in(i1,2) > 1 && panel_in(i1,15) == 1) %just unemployed or unemployed, disabled
                panel(i1,4) = (panel_in(i1,4)*t1)/(t1+1); %accumulated earnings
                aux_p = sum(panel_in(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel_in(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel_in(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_u_disab(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_u_disab(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                aux_ht = sum(h_dec+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                dist = abs(hgrid(aux_ht)-h_dec) %assure that h_dec is a discrete choice
                if (dist>10)
                    h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_u_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                    aux_ht = sum(h_dec+1>hgrid);
                    aux_ht = min(nh,aux_ht);
                    aux_ht = max(1,aux_ht);
                    dist = abs(hgrid(aux_ht)-h_dec); %assure that h_dec is a discrete choice
                    if (dist>10)
                        h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_u_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        aux_ht = sum(h_dec+1>hgrid);
                        aux_ht = min(nh,aux_ht);
                        aux_ht = max(1,aux_ht);
                        dist = abs(hgrid(aux_ht)-h_dec);
                        if (dist>10)
                            h_dec = policy_h_u_disab(a_temp,aux_nc,aux_p,aux_h,t1)
                            aux_ht = sum(h_dec+1>hgrid);
                            aux_ht = min(nh,aux_ht);
                            aux_ht = max(1,aux_ht);
                            k_dec = policy_a_u_disab(a_temp,aux_nc,aux_p,aux_h,t1);
                        else
                            k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_u_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        end
                    else
                        k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_u_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    end
                end
                
                aux_i_egl = floor(egl_b(t1))
                if (aux_i_egl==1)
                    if (k_dec>abar(t1) &&  k_dec<(abar(t1)+1000)) %possible extrapolation error
                        k_dec2=interp3_l(agrid,grid_nc,pgrid,policy_a_u_disab(:,:,:,aux_h,t1),agrid(a_temp),grid_nc(aux_nc),panel(i1,3),a_temp,aux_nc,aux_p);
                        if (k_dec2<(abar(t1)+10))
                            k_dec = abar(t1);
                        end
                    end
                end
                panel(i1,6) = max(min(k_dec,amax),amin);  %asset transition
                panel(i1,13) = hgrid(aux_ht) %house transition
                
                aux_ht = sum(panel(i1,13)+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                aux_p = sum(panel(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                
                e_dec=interp3_l(agrid,grid_nc,pgrid,emp_pol_u_disab(:,:,:,aux_ht,t1),panel(i1,6),panel(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                if (e_dec<0.5)%out of labor force
                    panel(i1,2) = 3;
                else
                    if (sim_offer(i1,1)<=offer_disab(t1)) %employment transitions
                        panel(i1,2) = 1;
                    else
                        panel(i1,2) = 3;
                    end
                end

            
        else %can apply for disability
            for i1 = 1:L
                    aux_h = sum(panel_in(i1,13)+1>hgrid);
                aux_h = min(nh,aux_h)
                aux_h = max(1,aux_h)
                    if (panel_in(i1,2) == 1 && panel_in(i1,15) == 0) %employed, non-disabled
                        w_t = lininter(pgrid,w(:,t1),panel_in(i1,3));
                w_gt = exp(panel_in(i1,3));
                panel(i1,4) = (panel_in(i1,4)*t1+w_gt)/(t1+1); %accumulated earnings
                aux_p = sum(panel_in(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel_in(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel_in(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                aux_ht = sum(h_dec+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                if (dist>10)
                    h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                    aux_ht = sum(h_dec+1>hgrid);
                    aux_ht = min(nh,aux_ht);
                    aux_ht = max(1,aux_ht);
                    dist = abs(hgrid(aux_ht)-h_dec); %assure that h_dec is a discrete choice
                    if (dist>10)
                        h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        aux_ht = sum(h_dec+1>hgrid);
                        aux_ht = min(nh,aux_ht);
                        aux_ht = max(1,aux_ht);
                        dist = abs(hgrid(aux_ht)-h_dec);
                        if (dist>10)
                            h_dec = policy_h_e(a_temp,aux_nc,aux_p,aux_h,t1)
                            aux_ht = sum(h_dec+1>hgrid);
                            aux_ht = min(nh,aux_ht);
                            aux_ht = max(1,aux_ht);
                            k_dec = policy_a_e(a_temp,aux_nc,aux_p,aux_h,t1);
                        else
                            k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        end
                    else
                        k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    end
                end
                
                if (w_gt<=ybarf_y(t1))
                    panel(i1,10) = 1;
                    if (k_dec>abar(t1) &&  k_dec<(abar(t1)+1000)) %possible extrapolation error
                        a_temp = sum(panel_in(i1,6)>agrid);
                        a_temp = max(a_temp,1);
                        a_temp = min(a_temp,na);
                        k_dec2=interp3_l(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),agrid(a_temp),grid_nc(aux_nc),panel(i1,3),a_temp,aux_nc,aux_p);
                        if (k_dec2<(abar(t1)+10))
                            k_dec = abar(t1);
                        end
                    end
                end
                panel(i1,6) = max(min(k_dec,amax),amin);
                panel(i1,13) = hgrid(aux_ht) %house transition
                
                aux_ht = sum(panel(i1,13)+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                aux_p = sum(panel(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                if (sim_destruct(i1,1)<=destruct_health(t1))
                    panel(i1,2) = 2;
                else
                    if (((panel(i1,3))-panel_in(i1,3))<d_cut)
                        e_dec=interp3_l(agrid,grid_nc,pgrid,emp_pol_e2(:,:,:,aux_ht,t1-(work-disab)),panel(i1,6),panel(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    if (e_dec<0.5)  %choose unemployment
                        panel(i1,2) = 2;
                    else
                        panel(i1,2) = 1;
                    end
                    else
                        e_dec=interp3_l(agrid,grid_nc,pgrid,emp_pol_e(:,:,:,aux_ht,t1),panel(i1,6),panel(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                        if (e_dec<0.5)  %choose unemployment
                            panel(i1,2) = 3;
                        else
                            panel(i1,2) = 1;
                        end
                    end
                end


           elseif (panel_in(i1,2) == 1 && panel_in(i1,15) == 1) %employed, disabled
                w_t = lininter(pgrid,wd(:,t1),panel_in(i1,3));
                w_gt = exp(panel_in(i1,3));
                panel(i1,4) = (panel_in(i1,4)*t1+w_gt)/(t1+1); %accumulated earnings
                aux_p = sum(panel_in(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel_in(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel_in(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e_disab(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e_disab(:,:,:,aux_h,t1),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                aux_ht = sum(h_dec+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                dist = abs(hgrid(aux_ht)-h_dec) %assure that h_dec is a discrete choice
                if (dist>10)
                    h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                    aux_ht = sum(h_dec+1>hgrid);
                    aux_ht = min(nh,aux_ht);
                    aux_ht = max(1,aux_ht);
                    dist = abs(hgrid(aux_ht)-h_dec); %assure that h_dec is a discrete choice
                    if (dist>10)
                        h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_e_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        aux_ht = sum(h_dec+1>hgrid);
                        aux_ht = min(nh,aux_ht);
                        aux_ht = max(1,aux_ht);
                        dist = abs(hgrid(aux_ht)-h_dec);
                        if (dist>10)
                            h_dec = policy_h_e_disab(a_temp,aux_nc,aux_p,aux_h,t1)
                            aux_ht = sum(h_dec+1>hgrid);
                            aux_ht = min(nh,aux_ht);
                            aux_ht = max(1,aux_ht);
                            k_dec = policy_a_e_disab(a_temp,aux_nc,aux_p,aux_h,t1);
                        else
                            k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                        end
                    else
                        k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_e_disab(:,:,:,aux_h,t1),agrid(a_temp),panel_in(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    end
                end
                       if (w_gt<=ybarf_y(t1))
                    if (k_dec>abar(t1) &&  k_dec<(abar(t1)+1000)) %possible extrapolation error
                        a_temp = sum(panel_in(i1,6)>agrid);
                        a_temp = max(a_temp,1);
                        a_temp = min(a_temp,na);
                        k_dec2=interp3_l(agrid,grid_nc,pgrid,policy_a_e_disab(:,:,:,aux_h,t1),agrid(a_temp),grid_nc(aux_nc),panel(i1,3),a_temp,aux_nc,aux_p);
                        if (k_dec2<(abar(t1)+10))
                            k_dec = abar(t1);
                        end
                    end
                end
                panel(i1,6) = max(min(k_dec,amax),amin);
                panel(i1,13) = hgrid(aux_ht) %house transition
                
                aux_ht = sum(panel(i1,13)+1>hgrid);
                aux_ht = min(nh,aux_ht);
                aux_ht = max(1,aux_ht);
                aux_p = sum(panel(i1,3)>pgrid);
                aux_p = min(n2,aux_p);
                aux_p = max(1,aux_p);
                aux_nc = sum(panel(i1,4)>grid_nc);
                aux_nc = min(nc,aux_nc);
                aux_nc = max(1,aux_nc);
                a_temp = sum(panel(i1,6)>agrid);
                a_temp = max(a_temp,1);
                a_temp = min(na,a_temp);
                
                if (sim_destruct(i1,1)<=destruct_disab(t1))
                    panel(i1,2) = 2;
                else
                    if (((panel(i1,3))-panel_in(i1,3))<d_cut)
                        e_dec=interp3_l(agrid,grid_nc,pgrid,emp_pol_e2_disab(:,:,:,aux_ht,t1-(work-disab)),panel(i1,6),panel(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                    if (e_dec<0.5)  %choose unemployment
                        panel(i1,2) = 2;
                    else
                        panel(i1,2) = 1;
                    end
                    else
                        e_dec=interp3_l(agrid,grid_nc,pgrid,emp_pol_e_disab(:,:,:,aux_ht,t1),panel(i1,6),panel(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                        if (e_dec<0.5)  %choose unemployment
                            panel(i1,2) = 3;
                        else
                            panel(i1,2) = 1;
                        end
                    end
                end
                    elseif (panel_in(i1,2,t1) == 2 && panel_in(i1,15) == 0) %just unemployed and eligible, non-disabled
                        panel(i1,4) = (panel_in(i1,4)*t1)/(t1+1); %accumulated earnings
                        aux_p = sum(panel_in(i1,3)>pgrid);
                        aux_p = min(n2,aux_p);
                        aux_p = max(1,aux_p);
                        aux_nc = sum(panel_in(i1,4)>grid_nc);
                        aux_nc = min(nc,aux_nc);
                        aux_nc = max(1,aux_nc);
                        a_temp = sum(panel_in(i1,6)>agrid);
                        a_temp = max(a_temp,1);
                        a_temp = min(na,a_temp);
                        k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_uj(:,:,:,aux_h,t1-(work-disab)),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                        h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_uj(:,:,:,aux_h,t1-(work-disab)),panel_in(i1,6),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                        aux_ht = sum(h_dec+1>hgrid);
                        aux_ht = min(nh,aux_ht);
                        aux_ht = max(1,aux_ht);
                        dist = abs(hgrid(aux_ht)-h_dec) %assure that h_dec is a discrete choice
                        if (dist>10)
                            h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_uj(:,:,:,aux_h,t1-(work-disab)),agrid(a_temp),panel_in(i1,4),panel_in(i1,3),a_temp,aux_nc,aux_p);
                            aux_ht = sum(h_dec+1>hgrid);
                            aux_ht = min(nh,aux_ht);
                            aux_ht = max(1,aux_ht);
                            dist = abs(hgrid(aux_ht)-h_dec); %assure that h_dec is a discrete choice
                            if (dist>10)
                                h_dec=interp3_l(agrid,grid_nc,pgrid,policy_h_uj(:,:,:,aux_h,t1-(work-disab)),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                                aux_ht = sum(h_dec+1>hgrid);
                                aux_ht = min(nh,aux_ht);
                                aux_ht = max(1,aux_ht);
                                dist = abs(hgrid(aux_ht)-h_dec);
                                if (dist>10)
                                    h_dec = policy_h_uj(a_temp,aux_nc,aux_p,aux_h,t1-(work-disab))
                                    aux_ht = sum(h_dec+1>hgrid);
                                    aux_ht = min(nh,aux_ht);
                                    aux_ht = max(1,aux_ht);
                                    k_dec = policy_a_uj(a_temp,aux_nc,aux_p,aux_h,t1-(work-disab));
                                else
                                    k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_uj(:,:,:,aux_h,t1-(work-disab)),agrid(a_temp),panel_in(i1,4),pgrid(aux_p),a_temp,aux_nc,aux_p);
                                end
                            else
                                k_dec=interp3_l(agrid,grid_nc,pgrid,policy_a_uj(:,:,:,aux_h,t1-(work-disab)),agrid(a_temp),panel_in(i1,4),panel(i1,3),a_temp,aux_nc,aux_p);
                            end
                        end
                        aux_i_egl = floor(egl_b(t1))
                if (aux_i_egl==1)
                    if (k_dec>abar(t1) &&  k_dec<(abar(t1)+1000)) %possible extrapolation error
                        k_dec2=interp3_l(agrid,grid_nc,pgrid,policy_a_uj(:,:,:,aux_h,t1-(work-disab)),agrid(a_temp),grid_nc(aux_nc),panel(i1,3),a_temp,aux_nc,aux_p);
                        if (k_dec2<(abar(t1)+10))
                            k_dec = abar(t1);
                        end
                    end
                end
                panel(i1,6) = max(min(k_dec,amax),amin);  %asset transition
                panel(i1,13) = hgrid(aux_ht); %house transition
                

                        
                        if ((panel(i1,3,t1)-panel(i1,3,t1-1))<d_cut) then !large negative productivity shock
                            call interp3(agrid,grid_nc,pgrid,d_pol(:,:,:,aux_ht,t1-(work-disab)),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1),d_dec)
                        else
                            d_dec=0.d0
                        end if
                        if (d_dec>=0.5) then !choose disability
                            panel(i1,14,t1) = 1.d0 !out of labor force
                            if (sim_dis(i1,t1) <= psi) then !moves to disability
                                panel(i1,2,t1+1) = 4.d0
                            else !move to unemployment
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        else !do not apply
                            call interp3(agrid,grid_nc,pgrid,emp_pol_u(:,:,:,aux_ht,t1),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                            if (e_dec<0.5) then !out of labor force
                                panel(i1,14,t1) = 1.d0
                                panel(i1,2,t1+1) = 3.d0
                            else
                                if (sim_offer(i1,t1)<=offer_health(t1)) then !employment transitions
                                    panel(i1,2,t1+1) = 1.d0
                                else
                                    panel(i1,2,t1+1) = 3.d0
                                end if
                            end if
                        end if
                    
                    
                    elseif (panel(i1,2,t1) == 2.d0 .and. panel(i1,15,t1) == 1.d0) then !just unemployed and eligible, disabled
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid_d,policy_a_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid_d,policy_h_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid_d &
                                ,policy_h_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid_d,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid_d &
                                    ,policy_h_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_uj_disab(a_temp,nc_temp,p_temp,aux_h,t1-(work-disab))
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_uj_disab(a_temp,nc_temp,p_temp,aux_h,t1-(work-disab))
                                else
                                    call interp3(agrid,grid_nc,pgrid_d &
                                        ,policy_a_uj_disab(:,:,:,aux_h,t1-(work-disab)) &
                                        ,na,nc,n2,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid_d &
                                    ,policy_a_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                        costs(3) = costs(3)+w_u(t1,1)
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        aux_i_egl = FLOOR(egl_b(t1)) 
                        if (aux_i_egl==1) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and. k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_uj_disab(:,:,:,aux_h,t1-(work-disab)) &
                                        ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        if (k_dec<=((abar(t1)+10.d0)) .AND. aux_i_egl==1) then
                            call interp3(agrid,grid_nc,pgrid_d,policy_s_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                S_aux = S_u(t1)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                        if ((panel(i1,3,t1)-panel(i1,3,t1-1))<d_cut) then !large negative productivity shock
                            call interp3(agrid,grid_nc,pgrid_d,d_pol_disab(:,:,:,aux_ht,t1-(work-disab)),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1),d_dec)
                        else
                            d_dec=0.d0
                        end if
                        if (d_dec>=0.5) then !choose disability
                            panel(i1,14,t1) = 1.d0 !out of labor force
                            if (sim_dis(i1,t1) <= psi_d) then !moves to disability
                                panel(i1,2,t1+1) = 4.d0
                            else !move to unemployment
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        else !do not apply
                            call interp3(agrid,grid_nc,pgrid_d,emp_pol_u_disab(:,:,:,aux_ht,t1),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                            if (e_dec<0.5) then !out of labor force
                                panel(i1,14,t1) = 1.d0
                                panel(i1,2,t1+1) = 3.d0
                            else
                                if (sim_offer(i1,t1)<=offer_disab(t1)) then !employment transitions
                                    panel(i1,2,t1+1) = 1.d0
                                else
                                    panel(i1,2,t1+1) = 3.d0
                                end if
                            end if
                        end if
                        
                    elseif (panel(i1,2,t1) == 3.d0 .and. panel(i1,15,t1) == 0.d0) then !unemployed and non-eligible, non-disabled
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_u(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_u(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                        costs(3) = costs(3)+w_u(t1,1)
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        aux_i_egl = FLOOR(egl_b(t1)) 
                        if (aux_i_egl==1) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1) &
                                        ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        if ((k_dec<=((abar(t1)+10.d0))) .AND. (aux_i_egl==1)) then
                            call interp3(agrid,grid_nc,pgrid,policy_s_u(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                S_aux = S_u(t1)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux    
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if     
                        call interp3(agrid,grid_nc,pgrid,emp_pol_u(:,:,:,aux_ht,t1),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                        if (e_dec<0.5) then !out of labor force
                            panel(i1,14,t1) = 1.d0
                            panel(i1,2,t1+1) = 3.d0
                        else
                            if (sim_offer(i1,t1)<=offer_health(t1)) then !employment transitions
                                panel(i1,2,t1+1) = 1.d0
                            else
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        end if
                        
                    
                    elseif (panel(i1,2,t1) == 3.d0 .and. panel(i1,15,t1) == 1.d0) then !unemployed and non-eligible, disabled
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid_d,policy_h_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid_d,policy_h_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid_d,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid_d,policy_h_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_u_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_u_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                        costs(3) = costs(3)+w_u(t1,1)
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        aux_i_egl = FLOOR(egl_b(t1)) 
                        if (aux_i_egl==1) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1) &
                                        ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        if ((k_dec<=((abar(t1)+10.d0))) .AND. (aux_i_egl==1)) then
                            call interp3(agrid,grid_nc,pgrid_d,policy_s_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                S_aux = S_u(t1)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux    
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if     
                        call interp3(agrid,grid_nc,pgrid_d,emp_pol_u_disab(:,:,:,aux_ht,t1),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                        if (e_dec<0.5) then !out of labor force
                            panel(i1,14,t1) = 1.d0
                            panel(i1,2,t1+1) = 3.d0
                        else
                            if (sim_offer(i1,t1)<=offer_disab(t1)) then !employment transitions
                                panel(i1,2,t1+1) = 1.d0
                            else
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        end if
                        
                        
                    else !disabled
                        call lininter(grid_nc,w_d(:,t1-(work-disab)),nc,panel(i1,4,t1),wd_aux)
                        call lininter(grid_nc,wgross_d(:,t1-(work-disab)),nc,panel(i1,4,t1),w_gt)
                        call interp2(agrid,grid_nc,policy_a_d(:,:,aux_h,t1-(work-disab)),na,nc &
                            ,panel(i1,6,t1),panel(i1,4,t1),k_dec)
                        call interp2(agrid,grid_nc,policy_h_d(:,:,aux_h,t1-(work-disab)),na,nc &
                            ,panel(i1,6,t1),panel(i1,4,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp2(agrid,grid_nc,policy_h_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                ,agrid(a_temp),panel(i1,4,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                h_dec = policy_h_d(a_temp,nc_temp,aux_h,t1-(work-disab))
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                k_dec = policy_a_d(a_temp,nc_temp,aux_h,t1-(work-disab))
                            else
                                call interp2(agrid,grid_nc,policy_a_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                    ,agrid(a_temp),panel(i1,4,t1),k_dec)
                            end if
                        end if
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        !call lininter(grid_nc,egl_d(:,t1-(work-disab)),nc,panel(i1,4,t1),aux_egl)
                        !aux_i_egl = FLOOR(aux_egl) 
                        !if (aux_i_egl==1) then w_gt
                        if (w_gt<=ybarf_o(t1)) then 
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp2(agrid,grid_nc,policy_a_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                    ,agrid(a_temp),grid_nc(nc_temp),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        call lininter(grid_nc,S_d(:,t1-(work-disab)),nc,panel(i1,4,t1),S_aux)
                        costs(1) = costs(1)+(w_gt-wd_aux)
                        costs(4) = costs(4)+w_gt
                        panel(i1,5,t1) = wd_aux
                        if ((k_dec<=((abar(t1)+10.d0))) .AND. (w_gt<=ybarf_o(t1))) then
                            call interp2(agrid,grid_nc,policy_s_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                ,panel(i1,6,t1),panel(i1,4,t1),s_dec)
                            if (s_dec<=0.5) then
                                panel(i1,7,t1) = R*panel(i1,6,t1)+wd_aux-aux_xi+S_aux &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+wd_aux-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+wd_aux-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                        panel(i1,14,t1) = 1.d0
                        panel(i1,2,t1+1) = 4.d0
                        panel(i1,4,t1+1) = panel(i1,4,t1)
                    end if
                    if (sim_death(i1,t1)>survival(t1)) then !household dies
                        !bequest = bequest+panel(i1,6,t1+1)+panel(i1,13,t1+1)
                        count_b = count_b+1.d0
                        panel(i1,:,t1+1) = 0.d0
                    else
                        panel(i1,12,t1+1) = 1.d0
                    end if
            end do
            
        end if
        

        panel(i1,8) = t1+1
    end if 
end do

end