function [V_int,policy_int,c_int,discontinuity_last] = last_period(w,I_retire,agrid,adiff,R,theta_b,gamma_b,gamma,Z,low_max_r_s,na,N,n,type,intergen_skill,health_life)

if type == 1 %no bequest 
    V_int = CARRA(I_retire-repmat(reshape(health_life',[1 1 n]),[na N 1]),gamma); 
    c_int = I_retire-repmat(reshape(health_life',[1 1 n]),[na N 1]);
    policy_int = I_retire-c_int-repmat(reshape(health_life',[1 1 n]),[na N 1]); 
    discontinuity_last = low_max_r_s;

elseif type==2 %bequest with theta_b*(a+Z)^(1-gamma)/(1-gamma)
    c_int = zeros(na,N,n);
    policy_int = zeros(na,N,n);
    V_int = zeros(na,N,n); 
    
    cprime = agrid; %consume agrid next period
    cprime = max(cprime,10^(-15));
    EV = CARRA(cprime+Z,gamma_b); %value of bequest agrid
    for i = 1:N
        for j = 1:n
            c = ((theta_b*R).^(-(1/gamma)))*(cprime+Z).^(gamma_b/gamma);
            k = agrid./R;
            a = c-(w(i,j)-health_life(j,1))+k;
            binding_constraints = agrid < a(1,1);
            c_int(:,i,j)=interp1_l(a,c,agrid);
            AUX= w(i,j)-health_life(j,1) + agrid;
            c_int(binding_constraints,i,j) = AUX(logical(binding_constraints));
            policy_int(:,i,j) = agrid+(w(i,j)-health_life(j,1))-c_int(:,i,j); %k choice
            anext = R*policy_int(:,i,j);
            V_int(:,i,j) = CARRA(c_int(:,i,j),gamma)+theta_b*interp1_l(agrid,EV,anext);
        end
    end
    
    discontinuity_last = zeros (N*n,3);
    for i = 1:N*n
        discontinuity_last(i,:) = low_max_r_s(i,1);
    end
    
else %OLS approximation to initial value function
    
    load('V_f.mat','V_f');
    V_e = V_f.e;
    V_u = V_f.u;
    clear V_f
    
    load('ini.mat','ini');
    initial_urate = ini.urate;
    
%     na2 = 10000; 
    na2 = na;
    atomo = agrid; %make grid equi-spaced
    adiff = diff(atomo);
    EV = zeros(na2,N,n);
    for j = 1:n
        for i = 1:N
            aux = 0;
            for k = 1:n
                aux = aux+intergen_skill(k,j)*((1-initial_urate)*V_e(:,i,k,1)+initial_urate*V_u(:,i,k,1)); %income is certain
            end
            EV(:,i,j) = interp1_l(agrid,aux,atomo);
%             reg = ols(EV(:,i,j),[ones(na,1) I_retire(:,i,j) I_retire(:,i,j).^2]);
            reg = ols(EV(:,i,j),[ones(na2,1) atomo atomo.^2]);
            aux = diff(reg.yhat);
            if min(aux)<0
                aux = find(aux<0,1,'first');
                EV(1:aux,i,j) = reg.yhat(1:aux,1);
                EV(aux+1:end,i,j) = reg.yhat(aux,1);
            else
                EV(:,i,j) = reg.yhat(:,1);
            end
        end
    end
    
    c_int = zeros(na,N,n);
    policy_int = zeros(na,N,n);
    V_int = zeros(na,N,n);
    
    for i = 1:N
        for j = 1:n
            B = (EV(2:end,i,j)-EV(1:end-1,i,j))./adiff(1:end,1);
            B = [B; (EV(end,i,j)-EV(end-1,i,j))./(agrid(end,1)-agrid(end-1,1))];
            B = max(B,10^(-16));
            c = (R*theta_b*B).^(-1/gamma);
            k = atomo./R;
            a = c-(w(i,j)-health_life(j,1))+k;
            binding_constraints = agrid < a(1,1);  
            c_int(:,i,j)=interp1_l(a,c,agrid);
            AUX= (w(i,j)-health_life(j,1)) + agrid;
            c_int(binding_constraints,i,j) = AUX(logical(binding_constraints));
            policy_int(:,i,j) = agrid+(w(i,j)-health_life(j,1))-c_int(:,i,j); %k choice
            anext = R*policy_int(:,i,j);
            V_int(:,i,j) = CARRA(c_int(:,i,j),gamma)+theta_b*interp1_l(atomo,EV(:,i,j),anext);
        end
    end
    
%     aux = 0;
%     parfor j = 1:n*N %not eligible
%         [V_aux(:,j),policy_aux(:,j),discontinuity_last(j,1)] =...
%             ind_work_no_test_exog_egm_mex(EV(:,j),EV(:,j),agrid,beta,int32(na),I_retire_s(:,j),w_retire_s(j,1),R,gamma,aux,int32(discontinuity_last(j,1)),adiff);
%     end
    
%     for j = 1:n
%         V_e(:,:,j,end) = V_aux(:,(j-1)*N+1:N*j);
%         policy_e(:,:,j,end) = policy_aux(:,(j-1)*N+1:N*j);
%     end
%     c_e(:,:,:,end) = I_retire - policy_e(:,:,:,end);
    
    discontinuity_last = low_max_r_s;
    
end




end