#include "fintrf.h"

!----------------------------------------------------------------------------
! Gateway routine
!----------------------------------------------------------------------------

subroutine mexFunction(nlhs,plhs,nrhs,prhs)
    implicit none
    
    ! Arguments in mexFunction
      mwPointer  :: plhs(*), prhs(*)
      integer    :: nlhs, nrhs
    
    ! Function declarations
      mwPointer     mxCreateNumericArray ,mxGetPr, mxGetM, mxGetN
      mwPointer     mxGetDimensions, mxCreateDoubleMatrix
      integer(4)    mxClassIDFromClassName
      mwSize        mxGetNumberOfDimensions
      
      ! Pointers to input/output mxArrays:
      ! Input
      mwPointer  :: H,T,work,retire,disab,old,n2,na,nc,amax,R,amin,destruct_health,offer_health,destruct_disab &
            ,offer_disab,born_prob,urate_ini,disab_ini,agrid,grid_nc,initial_asset_w,initial_asset_u,pgrid &
            ,pgrid_d,policy_a_e,policy_a_u,policy_a_uj,policy_a_d,policy_a_r,policy_a_e_disab,policy_a_u_disab &
            ,policy_a_uj_disab,emp_pol_e,emp_pol_u,emp_pol_e_disab,emp_pol_u_disab,emp_pol_e2,emp_pol_e2_disab &
            ,d_pol,d_pol_disab,S_w,S_u,S_d,S_r,S_wd,w,ben,w_d &
            ,w_r,wd,wgross_r,wgross_d,wdgross,abar,abar2,survival,w_u,health,wgross,egl_w,egl_b,egl_d,egl_r &
            ,egl_wd,psi,psi_d,mu1,mu2,delta1,delta2,disab_dis,pmin,pmax,prod_shock,hgrid,nh,policy_h_e,policy_h_u &
            ,policy_h_uj,policy_h_d,policy_h_r,policy_h_e_disab,policy_h_u_disab,policy_h_uj_disab &
            ,sim_initial_asset,sim_initial_perm,sim_initial_emp,sim_destruct,sim_offer,sim_death,sim_dis &
            ,sim_disab,sim_health,xi,d_cut,initial_asset_w_h,initial_asset_u_h,sim_initial_house &
            ,sim_initial_dis,tran_dh,tran_hd,policy_s_e,policy_s_u,policy_s_uj,policy_s_d,policy_s_r &
            ,policy_s_e_disab,policy_s_u_disab,policy_s_uj_disab,ybarf_y,ybarf_o,ybarss
            
	  !mwPointer   :: a

       ! Output
      mwPointer  :: panel,costs
      
    ! Array size information
      integer(4) :: Nx,complexFlag,classid                       ! length of input (output) array
	  mwSize     :: ndim
      mwSize     :: ndim2
      mwSize     :: dims(3)                    ! dimensions (for mxCreateNumericArray
      mwSize     :: dims2(1)

      
!--------------------------------------------------------------------------------    
      

	  classid = mxClassIDFromClassName('double')
      complexFlag = 0  
      
    ! Retrieve input parameter pointers

      H = mxGetPr(prhs(1))
      T = mxGetPr(prhs(2))
      work = mxGetPr(prhs(3))
      retire = mxGetPr(prhs(4))
	  disab = mxGetPr(prhs(5))
      old = mxGetPr(prhs(6))
	  n2 = mxGetPr(prhs(7))
	  na = mxGetPr(prhs(8))
      nc = mxGetPr(prhs(9))
	  amax = mxGetPr(prhs(10))
	  R = mxGetPr(prhs(11))
	  amin = mxGetPr(prhs(12))
	  destruct_health = mxGetPr(prhs(13))
	  offer_health = mxGetPr(prhs(14))
      destruct_disab = mxGetPr(prhs(15))
      offer_disab = mxGetPr(prhs(16))
	  born_prob = mxGetPr(prhs(17))
	  urate_ini = mxGetPr(prhs(18))
      disab_ini = mxGetPr(prhs(19))
	  agrid = mxGetPr(prhs(20))
      grid_nc = mxGetPr(prhs(21))
	  initial_asset_w = mxGetPr(prhs(22))
	  initial_asset_u = mxGetPr(prhs(23))
	  pgrid = mxGetPr(prhs(24))
      pgrid_d = mxGetPr(prhs(25))
	  policy_a_e = mxGetPr(prhs(26))
	  policy_a_u = mxGetPr(prhs(27))
	  policy_a_uj = mxGetPr(prhs(28))
      policy_a_d = mxGetPr(prhs(29))
      policy_a_r = mxGetPr(prhs(30))
      policy_a_e_disab = mxGetPr(prhs(31))
      policy_a_u_disab = mxGetPr(prhs(32))
      policy_a_uj_disab = mxGetPr(prhs(33))
      emp_pol_e = mxGetPr(prhs(34))
      emp_pol_u = mxGetPr(prhs(35))
      emp_pol_e_disab = mxGetPr(prhs(36))
      emp_pol_u_disab = mxGetPr(prhs(37))
      emp_pol_e2 = mxGetPr(prhs(38))
      emp_pol_e2_disab = mxGetPr(prhs(39))
      d_pol = mxGetPr(prhs(40))
      d_pol_disab = mxGetPr(prhs(41))
	  S_w = mxGetPr(prhs(42))
	  S_u = mxGetPr(prhs(43))
	  S_d = mxGetPr(prhs(44))
	  S_r = mxGetPr(prhs(45))
      S_wd = mxGetPr(prhs(46))
	  w = mxGetPr(prhs(47))
	  ben = mxGetPr(prhs(48))
	  w_d = mxGetPr(prhs(49))
	  w_r = mxGetPr(prhs(50))
      wd = mxGetPr(prhs(51))
      wgross_r = mxGetPr(prhs(52))
      wgross_d = mxGetPr(prhs(53))
      wdgross = mxGetPr(prhs(54))
	  abar = mxGetPr(prhs(55))
      abar2 = mxGetPr(prhs(56))
	  survival = mxGetPr(prhs(57))
	  w_u = mxGetPr(prhs(58))
	  health = mxGetPr(prhs(59))
	  wgross = mxGetPr(prhs(60))
	  egl_w = mxGetPr(prhs(61))
	  egl_b = mxGetPr(prhs(62))
	  egl_d = mxGetPr(prhs(63))
	  egl_r = mxGetPr(prhs(64))
      egl_wd = mxGetPr(prhs(65))
      psi = mxGetPr(prhs(66))
      psi_d = mxGetPr(prhs(67))
      mu1 = mxGetPr(prhs(68))
      mu2 = mxGetPr(prhs(69))
      delta1 = mxGetPr(prhs(70))
      delta2 = mxGetPr(prhs(71))
      disab_dis = mxGetPr(prhs(72))
      pmin = mxGetPr(prhs(73))
      pmax = mxGetPr(prhs(74))
      prod_shock = mxGetPr(prhs(75))
      hgrid = mxGetPr(prhs(76))
      nh = mxGetPr(prhs(77))
      policy_h_e = mxGetPr(prhs(78))
      policy_h_u = mxGetPr(prhs(79))
      policy_h_uj = mxGetPr(prhs(80))
      policy_h_d = mxGetPr(prhs(81))
      policy_h_r = mxGetPr(prhs(82))
      policy_h_e_disab = mxGetPr(prhs(83))
      policy_h_u_disab = mxGetPr(prhs(84))
      policy_h_uj_disab = mxGetPr(prhs(85))
      sim_initial_asset = mxGetPr(prhs(86)) 
      sim_initial_perm = mxGetPr(prhs(87))
      sim_initial_emp = mxGetPr(prhs(88))
      sim_destruct = mxGetPr(prhs(89))
      sim_offer = mxGetPr(prhs(90))
      sim_death = mxGetPr(prhs(91))
      sim_dis = mxGetPr(prhs(92))
      sim_disab = mxGetPr(prhs(93))
      sim_health = mxGetPr(prhs(94))
      xi = mxGetPr(prhs(95))
      d_cut = mxGetPr(prhs(96))
      initial_asset_w_h = mxGetPr(prhs(97))
      initial_asset_u_h = mxGetPr(prhs(98))
      sim_initial_house = mxGetPr(prhs(99))
      sim_initial_dis = mxGetPr(prhs(100))
      tran_dh = mxGetPr(prhs(101))
      tran_hd = mxGetPr(prhs(102))
      policy_s_e = mxGetPr(prhs(103))
      policy_s_u = mxGetPr(prhs(104))
      policy_s_uj = mxGetPr(prhs(105))
      policy_s_d = mxGetPr(prhs(106))
      policy_s_r = mxGetPr(prhs(107))
      policy_s_e_disab = mxGetPr(prhs(108))
      policy_s_u_disab = mxGetPr(prhs(109))
      policy_s_uj_disab = mxGetPr(prhs(110))
      ybarf_y = mxGetPr(prhs(111))
      ybarf_o = mxGetPr(prhs(112))
      ybarss = mxGetPr(prhs(113))
                       


	 ndim = 3
	 dims(1) = 65000
	 dims(2) = 15
	 dims(3) = 180
     
     ndim2 = 1
     dims2(1) = 5


     ! Create matrices for return arguments
	   plhs(1) = mxCreateNumericArray(ndim, dims, classid, complexflag)
	   plhs(2) = mxCreateNumericArray(ndim2, dims2, classid, complexflag)




	  panel = mxGetPr(plhs(1))
	  costs = mxGetPr(plhs(2))



	  !call sub_simulation(%val(panel),%val(H),%val(T))
	  call  sub_simulation(%val(panel),%val(costs) &
	  ,%val(H),%val(T),%val(work),%val(retire),%val(disab),%val(old),%val(n2),%val(na),%val(nc),%val(amax) &
          ,%val(R),%val(amin),%val(destruct_health),%val(offer_health),%val(destruct_disab),%val(offer_disab) &
          ,%val(born_prob),%val(urate_ini),%val(disab_ini),%val(agrid),%val(grid_nc),%val(initial_asset_w) &
          ,%val(initial_asset_u),%val(pgrid),%val(pgrid_d),%val(policy_a_e),%val(policy_a_u),%val(policy_a_uj) &
          ,%val(policy_a_d),%val(policy_a_r),%val(policy_a_e_disab),%val(policy_a_u_disab),%val(policy_a_uj_disab) &
          ,%val(emp_pol_e),%val(emp_pol_u),%val(emp_pol_e_disab),%val(emp_pol_u_disab),%val(emp_pol_e2) &
          ,%val(emp_pol_e2_disab),%val(d_pol),%val(d_pol_disab),%val(S_w),%val(S_u),%val(S_d),%val(S_r),%val(S_wd) &
          ,%val(w),%val(ben),%val(w_d),%val(w_r),%val(wd),%val(wgross_r),%val(wgross_d),%val(wdgross),%val(abar) &
          ,%val(abar2),%val(survival),%val(w_u),%val(health),%val(wgross),%val(egl_w),%val(egl_b),%val(egl_d) &
          ,%val(egl_r),%val(egl_wd),%val(psi),%val(psi_d),%val(mu1),%val(mu2),%val(delta1),%val(delta2) &
          ,%val(disab_dis),%val(pmin),%val(pmax),%val(prod_shock),%val(hgrid),%val(nh),%val(policy_h_e) &
          ,%val(policy_h_u),%val(policy_h_uj),%val(policy_h_d),%val(policy_h_r),%val(policy_h_e_disab) &
          ,%val(policy_h_u_disab),%val(policy_h_uj_disab),%val(sim_initial_asset),%val(sim_initial_perm) &
          ,%val(sim_initial_emp),%val(sim_destruct),%val(sim_offer),%val(sim_death),%val(sim_dis),%val(sim_disab) &
          ,%val(sim_health),%val(xi),%val(d_cut),%val(initial_asset_w_h),%val(initial_asset_u_h) &
          ,%val(sim_initial_house),%val(sim_initial_dis),%val(tran_dh),%val(tran_hd),%val(policy_s_e) &
          ,%val(policy_s_u),%val(policy_s_uj),%val(policy_s_d),%val(policy_s_r),%val(policy_s_e_disab) &
          ,%val(policy_s_u_disab),%val(policy_s_uj_disab),%val(ybarf_y),%val(ybarf_o),%val(ybarss))  
	  
        
      return  
      
end subroutine



subroutine sub_simulation(panel,costs &
			,H,T,work,retire,disab,old,n2,na,nc,amax,R,amin,destruct_health,offer_health,destruct_disab,offer_disab &
            ,born_prob,urate_ini,disab_ini,agrid,grid_nc,initial_asset_w,initial_asset_u,pgrid,pgrid_d,policy_a_e &
            ,policy_a_u,policy_a_uj,policy_a_d,policy_a_r,policy_a_e_disab,policy_a_u_disab,policy_a_uj_disab &
            ,emp_pol_e,emp_pol_u,emp_pol_e_disab,emp_pol_u_disab,emp_pol_e2,emp_pol_e2_disab,d_pol,d_pol_disab,S_w &
            ,S_u,S_d,S_r,S_wd,w,ben,w_d,w_r,wd,wgross_r,wgross_d,wdgross,abar,abar2,survival,w_u,health,wgross &
            ,egl_w,egl_b,egl_d,egl_r,egl_wd,psi,psi_d,mu1,mu2,delta1,delta2,disab_dis,pmin,pmax,prod_shock,hgrid &
            ,nh,policy_h_e,policy_h_u,policy_h_uj,policy_h_d,policy_h_r,policy_h_e_disab,policy_h_u_disab &
            ,policy_h_uj_disab,sim_initial_asset,sim_initial_perm,sim_initial_emp,sim_destruct,sim_offer,sim_death &
            ,sim_dis,sim_disab,sim_health,xi,d_cut,initial_asset_w_h,initial_asset_u_h,sim_initial_house &
            ,sim_initial_dis,tran_dh,tran_hd,policy_s_e,policy_s_u,policy_s_uj,policy_s_d &
            ,policy_s_r,policy_s_e_disab,policy_s_u_disab,policy_s_uj_disab,ybarf_y,ybarf_o,ybarss)


! Variables
implicit none


integer(4), intent(in)	     :: H,T,work,retire,disab,old,n2,na,nc,nh


real(8), dimension(H,15,T), intent(out)            :: panel
real(8), dimension(5),intent(out)                  :: costs
real(8), intent(in)                                :: amax,amin,abar2,R,urate_ini,disab_ini,xi
real(8), intent(in)                                :: psi,psi_d,mu1,mu2,delta1,delta2,disab_dis,pmin,pmax,d_cut
real(8), dimension(work), intent(in)               :: destruct_health,offer_health,destruct_disab,offer_disab
real(8), dimension(work), intent(in)               :: S_u,egl_b,tran_dh,tran_hd
real(8), dimension(work,2), intent(in)             :: w_u
real(8), dimension(n2), intent(in)                 :: born_prob,pgrid,pgrid_d
real(8), dimension(na), intent(in)                 :: agrid,initial_asset_w,initial_asset_u
real(8), dimension(nc), intent(in)                 :: grid_nc
real(8), dimension(nh), intent(in)                 :: hgrid,initial_asset_w_h,initial_asset_u_h
real(8), dimension(na,nc,n2,nh,work), intent(in)   :: policy_a_e,policy_a_u,policy_h_e,policy_h_u
real(8), dimension(na,nc,n2,nh,work), intent(in)   :: policy_a_e_disab,policy_a_u_disab,policy_s_e,policy_s_u
real(8), dimension(na,nc,n2,nh,work), intent(in)   :: policy_h_e_disab,policy_h_u_disab
real(8), dimension(na,nc,n2,nh,work), intent(in)   :: policy_s_e_disab,policy_s_u_disab
real(8), dimension(na,nc,n2,nh,disab), intent(in)  :: policy_a_uj,policy_h_uj,emp_pol_e2,emp_pol_e2_disab
real(8), dimension(na,nc,n2,nh,disab), intent(in)  :: policy_a_uj_disab,policy_h_uj_disab
real(8), dimension(na,nc,n2,nh,disab), intent(in)  :: policy_s_uj,policy_s_uj_disab
real(8), dimension(na,nc,nh,disab), intent(in)     :: policy_a_d,policy_h_d,policy_s_d
real(8), dimension(na,nc,nh,retire), intent(in)    :: policy_a_r,policy_h_r,policy_s_r
real(8), dimension(na,nc,n2,nh,work), intent(in)   :: emp_pol_e,emp_pol_u,emp_pol_e_disab,emp_pol_u_disab
real(8), dimension(na,nc,n2,nh,disab), intent(in)  :: d_pol,d_pol_disab
real(8), dimension(n2,work), intent(in)            :: S_w,S_wd,w,wd,ben,wgross,wdgross,egl_w,egl_wd
real(8), dimension(nc,disab), intent(in)           :: S_d,w_d,egl_d,wgross_d
real(8), dimension(nc,retire), intent(in)          :: S_r,w_r,egl_r,wgross_r
real(8), dimension(T), intent(in)                  :: survival,health,abar,ybarf_y,ybarf_o,ybarss
real(8), dimension(H,work), intent(in)             :: sim_destruct,sim_offer,sim_dis,sim_disab,sim_health
real(8), dimension(H,work), intent(in)             :: prod_shock
real(8), dimension(H), intent(in)                  :: sim_initial_asset,sim_initial_perm,sim_initial_emp
real(8), dimension(H), intent(in)                  :: sim_initial_house,sim_initial_dis
real(8), dimension(H,T), intent(in)                :: sim_death



!further variables
integer(4)               :: i1,i2,t1,pos,aux_wt,aux_w,aux_h,aux_ht,a_temp,p_temp,nc_temp,aux_i_egl
real(8), dimension(na)   :: initial_asset_w_sim,initial_asset_u_sim
real(8), dimension(nh)   :: initial_asset_w_h_sim,initial_asset_u_h_sim
real(8), dimension(n2)   :: born_prob_ini
real(8)                  :: count_b,w_t,w_gt,k_dec,h_dec,s_dec,k_dec2,dist,e_dec,d_dec,b_t,S_aux,wd_aux
real(8)                  :: wr_aux,aux_egl,aux_xi
character*120            :: line
real(8)                  :: xxx



!id and accumulated earnings
do i1=1,H
    panel(i1,1,1) = i1
    panel(i1,4,1) = 100.d0
end do


!employment status
do i1 =1,H
    if (sim_initial_emp(i1) <= urate_ini) then
        panel(i1,2,1) = 3.d0
    else
        panel(i1,2,1) = 1.d0
    end if 
end do


!assets
call cumsum(initial_asset_w,initial_asset_w_sim,na)
call cumsum(initial_asset_u,initial_asset_u_sim,na)


do i1 = 1,H
    if (panel(i1,2,1) == 1.d0) then
        call find_pos(initial_asset_w_sim,sim_initial_asset(i1),pos,na)
        pos = min(pos,na-1)
        panel(i1,6,1) = agrid(pos+1)
    else 
		call find_pos(initial_asset_u_sim,sim_initial_asset(i1),pos,na)
        pos = min(pos,na-1)
        panel(i1,6,1) = agrid(pos+1)
    end if
end do


!housing
call cumsum(initial_asset_w_h,initial_asset_w_h_sim,nh)
call cumsum(initial_asset_u_h,initial_asset_u_h_sim,nh)

do i1 = 1,H
    if (panel(i1,2,1) == 1.d0) then
        call find_pos(initial_asset_w_h_sim,sim_initial_house(i1),pos,nh)
        pos = min(pos,nh-1)
        panel(i1,13,1) = hgrid(pos+1)
    else 
		call find_pos(initial_asset_u_h_sim,sim_initial_house(i1),pos,nh)
        pos = min(pos,nh-1)
        panel(i1,13,1) = hgrid(pos+1)
    end if
end do

!disability status
do i1 =1,H
    if (sim_initial_dis(i1) <= disab_ini) then
        panel(i1,15,1) = 1.d0
    else
        panel(i1,15,1) = 0.d0
    end if 
end do


do i1 = 1,H

    panel(i1,3,1) = sim_initial_perm(i1)
    if (panel(i1,15,1) == 1.d0) then
        panel(i1,3,1) = panel(i1,3,1)-disab_dis
    end if
end do

do i1=1,H
    panel(i1,12,1) = 1.d0 !all households are allive
    panel(i1,14,1) = 0.d0 !out of labor force
end do

do i1 = 1,5
    costs(i1) = 0.d0
end do

count_b = 0.d0



do t1 = 1,(T-1)
    !call sub_mexWriteString('t1')
    do i1=1,H
        panel(i1,1,t1) = i1
        panel(i1,8,t1) = t1
        panel(i1,10,t1) = 0.d0
        panel(i1,11,t1) = 0.d0
        panel(i1,14,t1) = 0.d0
    end do
    
    !productivity transition
    do i1=1,H
        if (panel(i1,12,t1)==1.d0) then !allive
            if (t1 <= (work-old)) then
                if (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 0.d0) then !employed, non-disabled
                    panel(i1,3,t1+1) = min(pmax,max(pmin,panel(i1,3,t1)+mu1+prod_shock(i1,t1)))
                    if (sim_health(i1,t1)>tran_hd(t1)) then
                        panel(i1,15,t1+1)=0.d0
                    else
                        panel(i1,15,t1+1)=1.d0
                        panel(i1,3,t1+1) = max(pmin,panel(i1,3,t1+1)-disab_dis)
                    end if
                elseif (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 1.d0) then !employed, disabled
                    panel(i1,3,t1+1) = min(pmax,max(pmin,panel(i1,3,t1)+mu1+prod_shock(i1,t1)))
                    if (sim_health(i1,t1)>tran_dh(t1)) then
                        panel(i1,15,t1+1)=1.d0
                    else
                        panel(i1,15,t1+1)=0.d0
                        panel(i1,3,t1+1) = min(pmax,panel(i1,3,t1+1)+disab_dis)
                    end if
                elseif (panel(i1,2,t1) > 0.d0 .and. panel(i1,15,t1) == 0.d0) then !unemployed, non-disabled
                    panel(i1,3,t1+1) = min(pmax,max(pmin,panel(i1,3,t1)+delta1+prod_shock(i1,t1)))
                    if (sim_health(i1,t1)>tran_hd(t1)) then
                        panel(i1,15,t1+1)=0.d0
                    else
                        panel(i1,15,t1+1)=1.d0
                        panel(i1,3,t1+1) = max(pmin,panel(i1,3,t1+1)-disab_dis)
                    end if
                elseif (panel(i1,2,t1) > 0.d0 .and. panel(i1,15,t1) == 1.d0) then !unemployed, disabled   
                    panel(i1,3,t1+1) = min(pmax,max(pmin,panel(i1,3,t1)+delta1+prod_shock(i1,t1)))
                    if (sim_health(i1,t1)>tran_dh(t1)) then
                        panel(i1,15,t1+1)=1.d0
                    else
                        panel(i1,15,t1+1)=0.d0
                        panel(i1,3,t1+1) = min(pmax,panel(i1,3,t1+1)+disab_dis)
                    end if
                end if
            elseif (t1<=work) then
                if (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 0.d0) then !employed, non-disabled
                    panel(i1,3,t1+1) = min(pmax,max(pmin,panel(i1,3,t1)+mu2+prod_shock(i1,t1)))
                    if (sim_health(i1,t1)>tran_hd(t1)) then
                        panel(i1,15,t1+1)=0.d0
                    else
                        panel(i1,15,t1+1)=1.d0
                        panel(i1,3,t1+1) = max(pmin,panel(i1,3,t1+1)-disab_dis)
                    end if
                elseif (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 1.d0) then !employed, disabled
                    panel(i1,3,t1+1) = min(pmax,max(pmin,panel(i1,3,t1)+mu2+prod_shock(i1,t1)))
                    if (sim_health(i1,t1)>tran_dh(t1)) then
                        panel(i1,15,t1+1)=1.d0
                    else
                        panel(i1,15,t1+1)=0.d0
                        panel(i1,3,t1+1) = min(pmax,panel(i1,3,t1+1)+disab_dis)
                    end if
                elseif (panel(i1,2,t1) > 0.d0 .and. panel(i1,15,t1) == 0.d0) then !unemployed, non-disabled
                    panel(i1,3,t1+1) = min(pmax,max(pmin,panel(i1,3,t1)+delta2+prod_shock(i1,t1)))
                    if (sim_health(i1,t1)>tran_hd(t1)) then
                        panel(i1,15,t1+1)=0.d0
                    else
                        panel(i1,15,t1+1)=1.d0
                        panel(i1,3,t1+1) = max(pmin,panel(i1,3,t1+1)-disab_dis)
                    end if
                elseif (panel(i1,2,t1) > 0.d0 .and. panel(i1,15,t1) == 1.d0) then !unemployed, disabled   
                    panel(i1,3,t1+1) = min(pmax,max(pmin,panel(i1,3,t1)+delta2+prod_shock(i1,t1)))
                    if (sim_health(i1,t1)>tran_dh(t1)) then
                        panel(i1,15,t1+1)=1.d0
                    else
                        panel(i1,15,t1+1)=0.d0
                        panel(i1,3,t1+1) = min(pmax,panel(i1,3,t1+1)+disab_dis)
                    end if
                end if
            else
                panel(i1,3,t1+1)=panel(i1,3,t1)
                panel(i1,15,t1+1)=panel(i1,15,t1)
            end if
        end if
    end do
    

    if (t1 < work) then
        if (t1 <= (work-disab)) then !cannot apply
            do i1 = 1,H
                if (panel(i1,12,t1)==1.d0) then !allive
                    call find_pos(hgrid,panel(i1,13,t1)+1.d0,aux_h,nh)
                    aux_h = min(nh,aux_h)
                    aux_h = max(1,aux_h)
                    if (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 0.d0) then !employed, non-disabled
                        call lininter(pgrid,w(:,t1),n2,panel(i1,3,t1),w_t)
                        w_gt = exp(panel(i1,3,t1))

                        costs(1) = costs(1)+(w_gt-w_t)
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1)+w_gt)/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(na,a_temp)
                            call interp3(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_e(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_e(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if

                        if (w_gt<=ybarf_y(t1)) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        panel(i1,5,t1) = w_t
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        !if (k_dec<=((abar(t1)+10.d0)) .AND. aux_i_egl==1) then 
                        if (k_dec<=((abar(t1)+10.d0)) .AND. (w_gt<=ybarf_y(t1))) then 
                            call interp3(agrid,grid_nc,pgrid,policy_s_e(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                call lininter(pgrid,S_w(:,t1),n2,panel(i1,3,t1),S_aux)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-aux_xi &
                                    +S_aux-panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                        if (sim_destruct(i1,t1)<=destruct_health(t1)) then
                            panel(i1,2,t1+1) = 2.d0
                            panel(i1,6,t1+1) = panel(i1,6,t1+1)
                            costs(3) = costs(3)
                        else
                            call interp3(agrid,grid_nc,pgrid,emp_pol_e(:,:,:,aux_ht,t1),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                            if (e_dec<0.5) then !choose unemployment
                                panel(i1,2,t1+1) = 2.d0
                                panel(i1,6,t1+1) = panel(i1,6,t1+1)
                                costs(3) = costs(3)
                            else
                                panel(i1,2,t1+1) = 1.d0
                            end if
                        end if
                        panel(i1,9,t1) = panel(i1,6,t1)/w_gt !wealth to income ratio
                    
                    elseif (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 1.d0) then !employed, disabled
                        call lininter(pgrid_d,wd(:,t1),n2,panel(i1,3,t1),w_t)
                        w_gt = exp(panel(i1,3,t1))

                        costs(1) = costs(1)+(w_gt-w_t)
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1)+w_gt)/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid_d,policy_h_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(na,a_temp)
                            call interp3(agrid,grid_nc,pgrid_d,policy_h_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid_d,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid_d,policy_h_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_e_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_e_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if

                        if (w_gt<=ybarf_y(t1)) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        panel(i1,5,t1) = w_t
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if

                        if (k_dec<=((abar(t1)+10.d0)) .AND. (w_gt<=ybarf_y(t1))) then     
                            call interp3(agrid,grid_nc,pgrid_d,policy_s_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                call lininter(pgrid_d,S_wd(:,t1),n2,panel(i1,3,t1),S_aux)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-aux_xi &
                                    +S_aux-panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                        if (sim_destruct(i1,t1)<=destruct_disab(t1)) then
                            panel(i1,2,t1+1) = 2.d0
                            panel(i1,6,t1+1) = panel(i1,6,t1+1)
                            costs(3) = costs(3)
                        else
                            call interp3(agrid,grid_nc,pgrid_d,emp_pol_e_disab(:,:,:,aux_ht,t1),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                            if (e_dec<0.5) then !choose unemployment
                                panel(i1,2,t1+1) = 2.d0
                                panel(i1,6,t1+1) = panel(i1,6,t1+1)
                                costs(3) = costs(3)
                            else
                                panel(i1,2,t1+1) = 1.d0
                            end if
                        end if
                        panel(i1,9,t1) = panel(i1,6,t1)/w_gt !wealth to income ratio
                        
                    elseif (panel(i1,2,t1) > 1.d0 .and. panel(i1,15,t1) == 0.d0) then !just unemployed or unemployed, non-disabled
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(na,a_temp)
                            call interp3(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_u(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_u(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                                            ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                        costs(3) = costs(3)+w_u(t1,1)
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin)  !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        aux_i_egl = FLOOR(egl_b(t1)) 
                        if (aux_i_egl==1) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        if (k_dec<=((abar(t1)+10.d0)) .AND. aux_i_egl==1) then
                            call interp3(agrid,grid_nc,pgrid,policy_s_u(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                S_aux = S_u(t1)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if       
                        call interp3(agrid,grid_nc,pgrid,emp_pol_u(:,:,:,aux_ht,t1),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                        if (e_dec<0.5) then !out of labor force
                            panel(i1,14,t1) = 1.d0
                            panel(i1,2,t1+1) = 3.d0
                        else
                            if (sim_offer(i1,t1)<=offer_health(t1)) then !employment transitions
                                panel(i1,2,t1+1) = 1.d0
                            else
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        end if
                        
                    elseif (panel(i1,2,t1) > 1.d0 .and. panel(i1,15,t1) == 1.d0) then !just unemployed or unemployed, disabled
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid_d,policy_h_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(na,a_temp)
                            call interp3(agrid,grid_nc,pgrid_d,policy_h_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid_d,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid_d,policy_h_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_u_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_u_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                            ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                        costs(3) = costs(3)+w_u(t1,1)
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin)  !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        aux_i_egl = FLOOR(egl_b(t1)) 
                        if (aux_i_egl==1) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        if (k_dec<=((abar(t1)+10.d0)) .AND. aux_i_egl==1) then
                            call interp3(agrid,grid_nc,pgrid_d,policy_s_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                S_aux = S_u(t1)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if       
                        call interp3(agrid,grid_nc,pgrid_d,emp_pol_u_disab(:,:,:,aux_ht,t1),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                        if (e_dec<0.5) then !out of labor force
                            panel(i1,14,t1) = 1.d0
                            panel(i1,2,t1+1) = 3.d0
                        else
                            if (sim_offer(i1,t1)<=offer_disab(t1)) then !employment transitions
                                panel(i1,2,t1+1) = 1.d0
                            else
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        end if
                        
                    end if
                    
                    if (sim_death(i1,t1)>survival(t1)) then !household dies

                        count_b = count_b+1.d0
                        panel(i1,:,t1+1) = 0.d0
                    else
                        panel(i1,12,t1+1) = 1.d0
                    end if
                else !household is dead
                    panel(i1,:,t1+1) = 0.d0
                end if
            end do
            
        else !can apply for disability
            do i1 = 1,H
                if (panel(i1,12,t1)==1.d0) then !allive
                    call find_pos(hgrid,panel(i1,13,t1)+1.d0,aux_h,nh)
                    aux_h = min(nh,aux_h)
                    aux_h = max(1,aux_h)
                    if (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 0.d0) then !employed, non-disabled
                        call lininter(pgrid,w(:,t1),n2,panel(i1,3,t1),w_t)
                        w_gt = exp(panel(i1,3,t1))

                        costs(1) = costs(1)+w_gt-w_t
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1)+w_gt)/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(na,a_temp)
                            call interp3(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_e(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_e(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_t
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if

                        if (w_gt<=ybarf_y(t1)) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if

                        if (k_dec<=((abar(t1)+10.d0)) .AND. (w_gt<=ybarf_y(t1))) then 
                            call interp3(agrid,grid_nc,pgrid,policy_s_e(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                call lininter(pgrid,S_w(:,t1),n2,panel(i1,3,t1),S_aux)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-aux_xi &
                                    +S_aux-panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                        if (sim_destruct(i1,t1)<=destruct_health(t1)) then
                            panel(i1,6,t1+1) = panel(i1,6,t1+1)
                            costs(3) = costs(3)
                            if ((panel(i1,3,t1+1)-panel(i1,3,t1))<d_cut) then !large negative productivity shock
                                panel(i1,2,t1+1) = 2.d0
                            else
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        else
                            if ((panel(i1,3,t1+1)-panel(i1,3,t1))<d_cut) then !large negative productivity shock
                                call interp3(agrid,grid_nc,pgrid,emp_pol_e2(:,:,:,aux_ht,t1-(work-disab)),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                                if (e_dec<0.5) then !choose unemployment
                                    panel(i1,2,t1+1) = 2.d0
                                    panel(i1,6,t1+1) = panel(i1,6,t1+1)
                                    costs(3) = costs(3)
                                else
                                    panel(i1,2,t1+1) = 1.d0
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid,emp_pol_e(:,:,:,aux_ht,t1),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                                if (e_dec<0.5) then !choose unemployment
                                    panel(i1,2,t1+1) = 3.d0
                                    panel(i1,6,t1+1) = panel(i1,6,t1+1)
                                    costs(3) = costs(3)
                                else
                                    panel(i1,2,t1+1) = 1.d0
                                end if
                            end if
                        end if
                        panel(i1,9,t1) = panel(i1,6,t1)/w_gt !wealth to income ratio
                    
                    elseif (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 1.d0) then !employed, disabled
                        call lininter(pgrid_d,wd(:,t1),n2,panel(i1,3,t1),w_t)
                        w_gt = exp(panel(i1,3,t1))

                        costs(1) = costs(1)+w_gt-w_t
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1)+w_gt)/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid_d,policy_h_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(na,a_temp)
                            call interp3(agrid,grid_nc,pgrid_d,policy_h_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid_d,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid_d,policy_h_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_e_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_e_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_t
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if

                        if (w_gt<=ybarf_y(t1)) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if

                        if (k_dec<=((abar(t1)+10.d0)) .AND. (w_gt<=ybarf_y(t1))) then 
                            call interp3(agrid,grid_nc,pgrid_d,policy_s_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                call lininter(pgrid_d,S_wd(:,t1),n2,panel(i1,3,t1),S_aux)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-aux_xi &
                                    +S_aux-panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                        if (sim_destruct(i1,t1)<=destruct_disab(t1)) then
                            panel(i1,6,t1+1) = panel(i1,6,t1+1)
                            costs(3) = costs(3)
                            if ((panel(i1,3,t1+1)-panel(i1,3,t1))<d_cut) then !large negative productivity shock
                                panel(i1,2,t1+1) = 2.d0
                            else
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        else
                            if ((panel(i1,3,t1+1)-panel(i1,3,t1))<d_cut) then !large negative productivity shock
                                call interp3(agrid,grid_nc,pgrid_d,emp_pol_e2_disab(:,:,:,aux_ht,t1-(work-disab)),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                                if (e_dec<0.5) then !choose unemployment
                                    panel(i1,2,t1+1) = 2.d0
                                    panel(i1,6,t1+1) = panel(i1,6,t1+1)
                                    costs(3) = costs(3)
                                else
                                    panel(i1,2,t1+1) = 1.d0
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid_d,emp_pol_e_disab(:,:,:,aux_ht,t1),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                                if (e_dec<0.5) then !choose unemployment
                                    panel(i1,2,t1+1) = 3.d0
                                    panel(i1,6,t1+1) = panel(i1,6,t1+1)
                                    costs(3) = costs(3)
                                else
                                    panel(i1,2,t1+1) = 1.d0
                                end if
                            end if
                        end if
                        panel(i1,9,t1) = panel(i1,6,t1)/w_gt !wealth to income ratio
                        
                    elseif (panel(i1,2,t1) == 2.d0 .and. panel(i1,15,t1) == 0.d0) then !just unemployed and eligible, non-disabled
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid,policy_a_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid,policy_h_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid &
                                ,policy_h_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid &
                                    ,policy_h_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_uj(a_temp,nc_temp,p_temp,aux_h,t1-(work-disab))
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_uj(a_temp,nc_temp,p_temp,aux_h,t1-(work-disab))
                                else
                                    call interp3(agrid,grid_nc,pgrid &
                                        ,policy_a_uj(:,:,:,aux_h,t1-(work-disab)) &
                                        ,na,nc,n2,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid &
                                    ,policy_a_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                        costs(3) = costs(3)+w_u(t1,1)
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        aux_i_egl = FLOOR(egl_b(t1)) 
                        if (aux_i_egl==1) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid,policy_a_uj(:,:,:,aux_h,t1-(work-disab)) &
                                        ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        if (k_dec<=((abar(t1)+10.d0)) .AND. aux_i_egl==1) then
                            call interp3(agrid,grid_nc,pgrid,policy_s_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                S_aux = S_u(t1)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                        if ((panel(i1,3,t1)-panel(i1,3,t1-1))<d_cut) then !large negative productivity shock
                            call interp3(agrid,grid_nc,pgrid,d_pol(:,:,:,aux_ht,t1-(work-disab)),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1),d_dec)
                        else
                            d_dec=0.d0
                        end if
                        if (d_dec>=0.5) then !choose disability
                            panel(i1,14,t1) = 1.d0 !out of labor force
                            if (sim_dis(i1,t1) <= psi) then !moves to disability
                                panel(i1,2,t1+1) = 4.d0
                            else !move to unemployment
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        else !do not apply
                            call interp3(agrid,grid_nc,pgrid,emp_pol_u(:,:,:,aux_ht,t1),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                            if (e_dec<0.5) then !out of labor force
                                panel(i1,14,t1) = 1.d0
                                panel(i1,2,t1+1) = 3.d0
                            else
                                if (sim_offer(i1,t1)<=offer_health(t1)) then !employment transitions
                                    panel(i1,2,t1+1) = 1.d0
                                else
                                    panel(i1,2,t1+1) = 3.d0
                                end if
                            end if
                        end if
                    
                    
                    elseif (panel(i1,2,t1) == 2.d0 .and. panel(i1,15,t1) == 1.d0) then !just unemployed and eligible, disabled
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid_d,policy_a_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid_d,policy_h_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid_d &
                                ,policy_h_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid_d,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid_d &
                                    ,policy_h_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_uj_disab(a_temp,nc_temp,p_temp,aux_h,t1-(work-disab))
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_uj_disab(a_temp,nc_temp,p_temp,aux_h,t1-(work-disab))
                                else
                                    call interp3(agrid,grid_nc,pgrid_d &
                                        ,policy_a_uj_disab(:,:,:,aux_h,t1-(work-disab)) &
                                        ,na,nc,n2,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid_d &
                                    ,policy_a_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                        costs(3) = costs(3)+w_u(t1,1)
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        aux_i_egl = FLOOR(egl_b(t1)) 
                        if (aux_i_egl==1) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and. k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_uj_disab(:,:,:,aux_h,t1-(work-disab)) &
                                        ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        if (k_dec<=((abar(t1)+10.d0)) .AND. aux_i_egl==1) then
                            call interp3(agrid,grid_nc,pgrid_d,policy_s_uj_disab(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                S_aux = S_u(t1)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                        if ((panel(i1,3,t1)-panel(i1,3,t1-1))<d_cut) then !large negative productivity shock
                            call interp3(agrid,grid_nc,pgrid_d,d_pol_disab(:,:,:,aux_ht,t1-(work-disab)),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1),d_dec)
                        else
                            d_dec=0.d0
                        end if
                        if (d_dec>=0.5) then !choose disability
                            panel(i1,14,t1) = 1.d0 !out of labor force
                            if (sim_dis(i1,t1) <= psi_d) then !moves to disability
                                panel(i1,2,t1+1) = 4.d0
                            else !move to unemployment
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        else !do not apply
                            call interp3(agrid,grid_nc,pgrid_d,emp_pol_u_disab(:,:,:,aux_ht,t1),na,nc,n2 &
                                    ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                            if (e_dec<0.5) then !out of labor force
                                panel(i1,14,t1) = 1.d0
                                panel(i1,2,t1+1) = 3.d0
                            else
                                if (sim_offer(i1,t1)<=offer_disab(t1)) then !employment transitions
                                    panel(i1,2,t1+1) = 1.d0
                                else
                                    panel(i1,2,t1+1) = 3.d0
                                end if
                            end if
                        end if
                        
                    elseif (panel(i1,2,t1) == 3.d0 .and. panel(i1,15,t1) == 0.d0) then !unemployed and non-eligible, non-disabled
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid,policy_h_u(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_u(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_u(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                        costs(3) = costs(3)+w_u(t1,1)
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        aux_i_egl = FLOOR(egl_b(t1)) 
                        if (aux_i_egl==1) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid,policy_a_u(:,:,:,aux_h,t1) &
                                        ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        if ((k_dec<=((abar(t1)+10.d0))) .AND. (aux_i_egl==1)) then
                            call interp3(agrid,grid_nc,pgrid,policy_s_u(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                S_aux = S_u(t1)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux    
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if     
                        call interp3(agrid,grid_nc,pgrid,emp_pol_u(:,:,:,aux_ht,t1),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                        if (e_dec<0.5) then !out of labor force
                            panel(i1,14,t1) = 1.d0
                            panel(i1,2,t1+1) = 3.d0
                        else
                            if (sim_offer(i1,t1)<=offer_health(t1)) then !employment transitions
                                panel(i1,2,t1+1) = 1.d0
                            else
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        end if
                        
                    
                    elseif (panel(i1,2,t1) == 3.d0 .and. panel(i1,15,t1) == 1.d0) then !unemployed and non-eligible, disabled
                        panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                        call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        call interp3(agrid,grid_nc,pgrid_d,policy_h_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid_d,policy_h_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(pgrid_d,panel(i1,3,t1),p_temp,n2)
                                p_temp = max(p_temp,1)
                                p_temp = min(p_temp,n2)
                                call interp3(agrid,grid_nc,pgrid_d,policy_h_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),h_dec)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                dist = abs(hgrid(aux_ht)-h_dec)
                                if (dist>10.d0) then
                                    call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                    nc_temp = max(nc_temp,1)
                                    nc_temp = min(nc_temp,nc)
                                    h_dec = policy_h_u_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                    aux_ht = min(nh,aux_ht)
                                    aux_ht = max(1,aux_ht)
                                    k_dec = policy_a_u_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                else
                                    call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                        ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),k_dec)
                                end if
                            else
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                            end if
                        end if
                        panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                        costs(3) = costs(3)+w_u(t1,1)
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if
                        aux_i_egl = FLOOR(egl_b(t1)) 
                        if (aux_i_egl==1) then
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_u_disab(:,:,:,aux_h,t1) &
                                        ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        if ((k_dec<=((abar(t1)+10.d0))) .AND. (aux_i_egl==1)) then
                            call interp3(agrid,grid_nc,pgrid_d,policy_s_u_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                            if (s_dec<=0.5) then
                                S_aux = S_u(t1)
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux    
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if     
                        call interp3(agrid,grid_nc,pgrid_d,emp_pol_u_disab(:,:,:,aux_ht,t1),na,nc,n2 &
                                ,panel(i1,6,t1+1),panel(i1,4,t1+1),panel(i1,3,t1+1),e_dec)
                        if (e_dec<0.5) then !out of labor force
                            panel(i1,14,t1) = 1.d0
                            panel(i1,2,t1+1) = 3.d0
                        else
                            if (sim_offer(i1,t1)<=offer_disab(t1)) then !employment transitions
                                panel(i1,2,t1+1) = 1.d0
                            else
                                panel(i1,2,t1+1) = 3.d0
                            end if
                        end if
                        
                        
                    else !disabled
                        call lininter(grid_nc,w_d(:,t1-(work-disab)),nc,panel(i1,4,t1),wd_aux)
                        call lininter(grid_nc,wgross_d(:,t1-(work-disab)),nc,panel(i1,4,t1),w_gt)
                        call interp2(agrid,grid_nc,policy_a_d(:,:,aux_h,t1-(work-disab)),na,nc &
                            ,panel(i1,6,t1),panel(i1,4,t1),k_dec)
                        call interp2(agrid,grid_nc,policy_h_d(:,:,aux_h,t1-(work-disab)),na,nc &
                            ,panel(i1,6,t1),panel(i1,4,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp2(agrid,grid_nc,policy_h_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                ,agrid(a_temp),panel(i1,4,t1),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                            if (dist>10.d0) then
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                h_dec = policy_h_d(a_temp,nc_temp,aux_h,t1-(work-disab))
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                k_dec = policy_a_d(a_temp,nc_temp,aux_h,t1-(work-disab))
                            else
                                call interp2(agrid,grid_nc,policy_a_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                    ,agrid(a_temp),panel(i1,4,t1),k_dec)
                            end if
                        end if
                        panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                        panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                        if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                            aux_xi = xi
                        else
                            aux_xi=0.d0
                        end if

                        if (w_gt<=ybarf_o(t1)) then 
                            panel(i1,10,t1) = 1.d0
                            if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                                a_temp = max(a_temp,1)
                                a_temp = min(a_temp,na)
                                call interp2(agrid,grid_nc,policy_a_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                    ,agrid(a_temp),grid_nc(nc_temp),k_dec2)
                                if (k_dec2<(abar(t1)+10.d0)) then
                                    k_dec = abar(t1)
                                end if
                            end if
                        end if
                        call lininter(grid_nc,S_d(:,t1-(work-disab)),nc,panel(i1,4,t1),S_aux)
                        costs(1) = costs(1)+(w_gt-wd_aux)
                        costs(4) = costs(4)+w_gt
                        panel(i1,5,t1) = wd_aux
                        if ((k_dec<=((abar(t1)+10.d0))) .AND. (w_gt<=ybarf_o(t1))) then
                            call interp2(agrid,grid_nc,policy_s_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                ,panel(i1,6,t1),panel(i1,4,t1),s_dec)
                            if (s_dec<=0.5) then
                                panel(i1,7,t1) = R*panel(i1,6,t1)+wd_aux-aux_xi+S_aux &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                                panel(i1,11,t1) = S_aux
                                costs(2) = costs(2)+S_aux
                            else
                                panel(i1,7,t1) = R*panel(i1,6,t1)+wd_aux-health(t1)-aux_xi &
                                    -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            end if
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+wd_aux-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                        panel(i1,14,t1) = 1.d0
                        panel(i1,2,t1+1) = 4.d0
                        panel(i1,4,t1+1) = panel(i1,4,t1)
                    end if
                    if (sim_death(i1,t1)>survival(t1)) then !household dies

                        count_b = count_b+1.d0
                        panel(i1,:,t1+1) = 0.d0
                    else
                        panel(i1,12,t1+1) = 1.d0
                    end if
                else !household is dead
                    panel(i1,:,t1+1) = 0.d0
                end if
            end do
            
        end if
        
    elseif (t1==work) then !last working period
        do i1 = 1,H
            if (panel(i1,12,t1)==1.d0) then !allive
                call find_pos(hgrid,panel(i1,13,t1)+1.d0,aux_h,nh)
                aux_h = min(nh,aux_h)
                aux_h = max(1,aux_h)
                if (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 0.d0) then !employed, non-disabled
                    call lininter(pgrid,w(:,t1),n2,panel(i1,3,t1),w_t)
                    w_gt = exp(panel(i1,3,t1))

                    costs(1) = costs(1)+w_gt-w_t
                    panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1)+w_gt)/(real(t1)+1.d0) !accumulated earnings
                    call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                        ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                    call interp3(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),na,nc,n2 &
                        ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                    aux_ht = min(nh,aux_ht)
                    aux_ht = max(1,aux_ht)
                    dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice    
                    if (dist>10.d0) then
                        call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                        a_temp = max(a_temp,1)
                        a_temp = min(a_temp,na)
                        call interp3(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),na,nc,n2 &
                            ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(pgrid,panel(i1,3,t1),p_temp,n2)
                            p_temp = max(p_temp,1)
                            p_temp = min(p_temp,n2)
                            call interp3(agrid,grid_nc,pgrid,policy_h_e(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec)
                            if (dist>10.d0) then
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                h_dec = policy_h_e(a_temp,nc_temp,p_temp,aux_h,t1)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                k_dec = policy_a_e(a_temp,nc_temp,p_temp,aux_h,t1)
                            else
                                call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),k_dec)
                            end if
                        else
                            call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        end if
                    end if
                    panel(i1,5,t1) = w_t
                    panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                    panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                    if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                        aux_xi = xi
                    else
                        aux_xi=0.d0
                    end if

                    if (w_gt<=ybarf_y(t1)) then
                        panel(i1,10,t1) = 1.d0
                        if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                            call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                            nc_temp = max(nc_temp,1)
                            nc_temp = min(nc_temp,nc)
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid,policy_a_e(:,:,:,aux_h,t1) &
                                    ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                            if (k_dec2<(abar(t1)+10.d0)) then
                                k_dec = abar(t1)
                            end if
                        end if
                    end if
                    call lininter(pgrid,S_w(:,t1),n2,panel(i1,3,t1),S_aux)

                    if (k_dec<=((abar(t1)+10.d0)) .AND. (w_gt<=ybarf_y(t1))) then     
                        call interp3(agrid,grid_nc,pgrid,policy_s_e(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                        if (s_dec<=0.5) then
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-aux_xi &
                                +S_aux-panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            panel(i1,11,t1) = S_aux
                            costs(2) = costs(2)+S_aux
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                    else
                        panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                            -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                    end if     
                    panel(i1,2,t1+1) = 5.d0 !go to retirement
                    panel(i1,9,t1) = panel(i1,6,t1)/w_gt !wealth to income ratio
                
                
                elseif (panel(i1,2,t1) == 1.d0 .and. panel(i1,15,t1) == 1.d0) then !employed, non-disabled
                    call lininter(pgrid_d,wd(:,t1),n2,panel(i1,3,t1),w_t)
                    w_gt = exp(panel(i1,3,t1))

                    costs(1) = costs(1)+w_gt-w_t
                    panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1)+w_gt)/(real(t1)+1.d0) !accumulated earnings
                    call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                        ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                    call interp3(agrid,grid_nc,pgrid_d,policy_h_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                        ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                    aux_ht = min(nh,aux_ht)
                    aux_ht = max(1,aux_ht)
                    dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice    
                    if (dist>10.d0) then
                        call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                        a_temp = max(a_temp,1)
                        a_temp = min(a_temp,na)
                        call interp3(agrid,grid_nc,pgrid_d,policy_h_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(pgrid_d,panel(i1,3,t1),p_temp,n2)
                            p_temp = max(p_temp,1)
                            p_temp = min(p_temp,n2)
                            call interp3(agrid,grid_nc,pgrid_d,policy_h_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec)
                            if (dist>10.d0) then
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                h_dec = policy_h_e_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                k_dec = policy_a_e_disab(a_temp,nc_temp,p_temp,aux_h,t1)
                            else
                                call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                    ,agrid(a_temp),panel(i1,4,t1),pgrid_d(p_temp),k_dec)
                            end if
                        else
                            call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        end if
                    end if
                    panel(i1,5,t1) = w_t
                    panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                    panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                    if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                        aux_xi = xi
                    else
                        aux_xi=0.d0
                    end if

                    if (w_gt<=ybarf_y(t1)) then
                        panel(i1,10,t1) = 1.d0
                        if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                            call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                            nc_temp = max(nc_temp,1)
                            nc_temp = min(nc_temp,nc)
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid_d,policy_a_e_disab(:,:,:,aux_h,t1) &
                                    ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                            if (k_dec2<(abar(t1)+10.d0)) then
                                k_dec = abar(t1)
                            end if
                        end if
                    end if
                    call lininter(pgrid_d,S_wd(:,t1),n2,panel(i1,3,t1),S_aux)

                    if (k_dec<=((abar(t1)+10.d0)) .AND. (w_gt<=ybarf_y(t1))) then 
                        call interp3(agrid,grid_nc,pgrid_d,policy_s_e_disab(:,:,:,aux_h,t1),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                        if (s_dec<=0.5) then
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-aux_xi &
                                +S_aux-panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            panel(i1,11,t1) = S_aux
                            costs(2) = costs(2)+S_aux
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                    else
                        panel(i1,7,t1) = R*panel(i1,6,t1)+w_t-health(t1)-aux_xi &
                            -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                    end if     
                    panel(i1,2,t1+1) = 5.d0 !go to retirement
                    panel(i1,9,t1) = panel(i1,6,t1)/w_gt !wealth to income ratio
                    
                    
                elseif (panel(i1,2,t1) > 1.d0 .and. panel(i1,2,t1) < 4.d0) then !unemployed, disability state does not matter
                    panel(i1,4,t1+1) = (panel(i1,4,t1)*real(t1))/(real(t1)+1.d0) !accumulated earnings
                    call interp3(agrid,grid_nc,pgrid,policy_a_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                        ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                    call interp3(agrid,grid_nc,pgrid,policy_h_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                        ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                    aux_ht = min(nh,aux_ht)
                    aux_ht = max(1,aux_ht)
                    dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                    if (dist>10.d0) then
                        call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                        a_temp = max(a_temp,1)
                        a_temp = min(a_temp,na)
                        call interp3(agrid,grid_nc,pgrid &
                            ,policy_h_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                            ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(pgrid,panel(i1,3,t1),p_temp,n2)
                            p_temp = max(p_temp,1)
                            p_temp = min(p_temp,n2)
                            call interp3(agrid,grid_nc,pgrid &
                                ,policy_h_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),h_dec)
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            dist = abs(hgrid(aux_ht)-h_dec)
                            if (dist>10.d0) then
                                call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                                nc_temp = max(nc_temp,1)
                                nc_temp = min(nc_temp,nc)
                                h_dec = policy_h_uj(a_temp,nc_temp,p_temp,aux_h,t1-(work-disab))
                                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                                aux_ht = min(nh,aux_ht)
                                aux_ht = max(1,aux_ht)
                                k_dec = policy_a_uj(a_temp,nc_temp,p_temp,aux_h,t1-(work-disab))
                            else
                                call interp3(agrid,grid_nc,pgrid &
                                    ,policy_a_uj(:,:,:,aux_h,t1-(work-disab)) &
                                    ,na,nc,n2,agrid(a_temp),panel(i1,4,t1),pgrid(p_temp),k_dec)
                            end if
                        else
                            call interp3(agrid,grid_nc,pgrid &
                                ,policy_a_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                                ,agrid(a_temp),panel(i1,4,t1),panel(i1,3,t1),k_dec)
                        end if
                    end if
                    panel(i1,5,t1) = w_u(t1,1)+w_u(t1,2)
                    costs(3) = costs(3)+w_u(t1,1)
                    panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                    panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                    if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                        aux_xi = xi
                    else
                        aux_xi=0.d0
                    end if
                    aux_i_egl = FLOOR(egl_b(t1)) 
                    if (aux_i_egl==1) then
                        panel(i1,10,t1) = 1.d0
                        if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                            call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                            nc_temp = max(nc_temp,1)
                            nc_temp = min(nc_temp,nc)
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp3(agrid,grid_nc,pgrid,policy_a_uj(:,:,:,aux_h,t1-(work-disab)) &
                                    ,na,nc,n2,agrid(a_temp),grid_nc(nc_temp),panel(i1,3,t1),k_dec2)
                            if (k_dec2<(abar(t1)+10.d0)) then
                                k_dec = abar(t1)
                            end if
                        end if
                    end if    
                    if (k_dec<=((abar(t1)+10.d0)) .AND. aux_i_egl==1) then
                        call interp3(agrid,grid_nc,pgrid,policy_s_uj(:,:,:,aux_h,t1-(work-disab)),na,nc,n2 &
                            ,panel(i1,6,t1),panel(i1,4,t1),panel(i1,3,t1),s_dec)
                        if (s_dec<=0.5) then
                            S_aux = S_u(t1)
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)+S_aux-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            panel(i1,11,t1) = S_aux
                            costs(2) = costs(2)+S_aux
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                    else
                        panel(i1,7,t1) = R*panel(i1,6,t1)+w_u(t1,1)+w_u(t1,2)-health(t1)-aux_xi &
                            -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                    end if
                    panel(i1,14,t1) = 1.d0
                    panel(i1,2,t1+1) = 5.d0 !go to retirement
                    
                else !disabled
                    panel(i1,4,t1+1) = panel(i1,4,t1) !accumulated earnings
                    call lininter(grid_nc,w_d(:,t1-(work-disab)),nc,panel(i1,4,t1),wd_aux)
                    call lininter(grid_nc,wgross_d(:,t1-(work-disab)),nc,panel(i1,4,t1),w_gt)
                    call interp2(agrid,grid_nc,policy_a_d(:,:,aux_h,t1-(work-disab)),na,nc &
                        ,panel(i1,6,t1),panel(i1,4,t1),k_dec)
                    call interp2(agrid,grid_nc,policy_h_d(:,:,aux_h,t1-(work-disab)),na,nc &
                        ,panel(i1,6,t1),panel(i1,4,t1),h_dec)
                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                    aux_ht = min(nh,aux_ht)
                    aux_ht = max(1,aux_ht)
                    dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                    if (dist>10.d0) then
                        call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                        a_temp = max(a_temp,1)
                        a_temp = min(a_temp,na)
                        call interp2(agrid,grid_nc,policy_h_d(:,:,aux_h,t1-(work-disab)),na,nc &
                            ,agrid(a_temp),panel(i1,4,t1),h_dec)
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                        if (dist>10.d0) then
                            call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                            nc_temp = max(nc_temp,1)
                            nc_temp = min(nc_temp,nc)
                            h_dec = policy_h_d(a_temp,nc_temp,aux_h,t1-(work-disab))
                            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                            aux_ht = min(nh,aux_ht)
                            aux_ht = max(1,aux_ht)
                            k_dec = policy_a_d(a_temp,nc_temp,aux_h,t1-(work-disab))
                        else
                            call interp2(agrid,grid_nc,policy_a_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                ,agrid(a_temp),panel(i1,4,t1),k_dec)
                        end if
                    end if
                    panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                    panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                    if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                        aux_xi = xi
                    else
                        aux_xi=0.d0
                    end if
                    call lininter(grid_nc,S_d(:,t1-(work-disab)),nc,panel(i1,4,t1),S_aux)

                    costs(1) = costs(1)+(w_gt-wd_aux)
                    costs(4) = costs(4)+w_gt

                    if (w_gt<=ybarf_o(t1)) then
                        panel(i1,10,t1) = 1.d0
                        if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                            call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                            nc_temp = max(nc_temp,1)
                            nc_temp = min(nc_temp,nc)
                            call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                            a_temp = max(a_temp,1)
                            a_temp = min(a_temp,na)
                            call interp2(agrid,grid_nc,policy_a_d(:,:,aux_h,t1-(work-disab)),na,nc &
                                ,agrid(a_temp),grid_nc(nc_temp),k_dec2)
                            if (k_dec2<(abar(t1)+10.d0)) then
                                k_dec = abar(t1)
                            end if
                        end if
                    end if
                    panel(i1,5,t1) = wd_aux

                    if (k_dec<=((abar(t1)+10.d0)) .AND. (w_gt<=ybarf_o(t1))) then 
                        call interp2(agrid,grid_nc,policy_s_d(:,:,aux_h,t1-(work-disab)),na,nc &
                            ,panel(i1,6,t1),panel(i1,4,t1),s_dec)
                        if (s_dec<=0.5) then
                            panel(i1,7,t1) = R*panel(i1,6,t1)+wd_aux-aux_xi+S_aux &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                            panel(i1,11,t1) = S_aux
                            costs(2) = costs(2)+S_aux
                        else
                            panel(i1,7,t1) = R*panel(i1,6,t1)+wd_aux-health(t1)-aux_xi &
                                -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        end if
                    else
                        panel(i1,7,t1) = R*panel(i1,6,t1)+wd_aux-health(t1)-aux_xi &
                            -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                    end if
                    panel(i1,14,t1) = 1.d0
                    panel(i1,2,t1+1) = 5.d0  
                end if
                
                if (sim_death(i1,t1)>survival(t1)) then !household dies

                    count_b = count_b+1.d0
                    panel(i1,:,t1+1) = 0.d0
                else
                    panel(i1,12,t1+1) = 1.d0
                end if
            else !household is dead
                panel(i1,:,t1+1) = 0.d0
            end if
        end do
        
    else !retirement
        do i1 = 1,H
            if (panel(i1,12,t1)==1.d0) then !allive
                panel(i1,4,t1+1) = panel(i1,4,t1) !accumulated earnings transition
                call find_pos(hgrid,panel(i1,13,t1)+1.d0,aux_h,nh)
                aux_h = min(nh,aux_h)
                aux_h = max(1,aux_h)
                call lininter(grid_nc,w_r(:,t1-(work)),nc,panel(i1,4,t1),wr_aux)
                call lininter(grid_nc,wgross_r(:,t1-(work)),nc,panel(i1,4,t1),w_gt)
                costs(1) = costs(1)+(w_gt-wr_aux)
                call interp2(agrid,grid_nc,policy_a_r(:,:,aux_h,t1-(work)),na,nc &
                    ,panel(i1,6,t1),panel(i1,4,t1),k_dec)
                call interp2(agrid,grid_nc,policy_h_r(:,:,aux_h,t1-(work)),na,nc &
                    ,panel(i1,6,t1),panel(i1,4,t1),h_dec)
                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                aux_ht = min(nh,aux_ht)
                aux_ht = max(1,aux_ht)
                dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                if (dist>10.d0) then
                    call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                    a_temp = max(a_temp,1)
                    a_temp = min(a_temp,na)
                    call interp2(agrid,grid_nc,policy_h_r(:,:,aux_h,t1-(work)),na,nc &
                        ,agrid(a_temp),panel(i1,4,t1),h_dec)
                    call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                    aux_ht = min(nh,aux_ht)
                    aux_ht = max(1,aux_ht)
                    dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
                    if (dist>10.d0) then
                        call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                        nc_temp = max(nc_temp,1)
                        nc_temp = min(nc_temp,nc)
                        h_dec = policy_h_r(a_temp,nc_temp,aux_h,t1-(work))
                        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                        aux_ht = min(nh,aux_ht)
                        aux_ht = max(1,aux_ht)
                        k_dec = policy_a_r(a_temp,nc_temp,aux_h,t1-(work))
                    else
                        call interp2(agrid,grid_nc,policy_a_r(:,:,aux_h,t1-(work)),na,nc &
                                ,agrid(a_temp),panel(i1,4,t1),k_dec)
                    end if
                end if
                panel(i1,6,t1+1) = max(min(k_dec,amax),amin) !asset transition
                panel(i1,13,t1+1) = hgrid(aux_ht) !house transition
                if (panel(i1,13,t1+1) /= panel(i1,13,t1)) then !adjustment costs
                    aux_xi = xi
                else
                    aux_xi=0.d0
                end if
                call lininter(grid_nc,S_r(:,t1-(work)),nc,panel(i1,4,t1),S_aux)

                costs(5) = costs(5)+w_gt

                if (w_gt<=ybarf_o(t1)) then
                    panel(i1,10,t1) = 1
                    if (k_dec>abar(t1) .and.  k_dec<(abar(t1)+1000.d0)) then !possible extrapolation error
                        call find_pos(grid_nc,panel(i1,4,t1),nc_temp,nc)
                        nc_temp = max(nc_temp,1)
                        nc_temp = min(nc_temp,nc)
                        call find_pos(agrid,panel(i1,6,t1),a_temp,na)
                        a_temp = max(a_temp,1)
                        a_temp = min(a_temp,na)
                        call interp2(agrid,grid_nc,policy_a_r(:,:,aux_h,t1-(work)),na,nc &
                            ,agrid(a_temp),grid_nc(nc_temp),k_dec2)

                        if (k_dec2<(abar(t1)+10.d0)) then
                            k_dec = abar(t1)
                        end if
                    end if
                end if
                panel(i1,5,t1) = wr_aux

                if (k_dec<=((abar(t1)+10.d0)) .AND. (w_gt<=ybarf_o(t1))) then 
                    call interp2(agrid,grid_nc,policy_s_r(:,:,aux_h,t1-(work)),na,nc &
                        ,panel(i1,6,t1),panel(i1,4,t1),s_dec)
                    if (s_dec<=0.5) then
                        panel(i1,7,t1) = R*panel(i1,6,t1)+wr_aux+S_aux-aux_xi &
                            -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                        panel(i1,11,t1) = S_aux
                        costs(2) = costs(2)+S_aux
                    else
                        panel(i1,7,t1) = R*panel(i1,6,t1)+wr_aux-health(t1)-aux_xi &
                            -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                    end if
                else
                    panel(i1,7,t1) = R*panel(i1,6,t1)+wr_aux-health(t1)-aux_xi &
                        -panel(i1,6,t1+1)-(panel(i1,13,t1+1)-panel(i1,13,t1)) !consumption
                end if                
                panel(i1,2,t1+1) = 5.d0
                if (sim_death(i1,t1)>survival(t1)) then !household dies

                    count_b = count_b+1.d0
                    panel(i1,:,t1+1) = 0.d0
                else
                    panel(i1,12,t1+1) = 1.d0
                end if
                
            else !household is dead
                panel(i1,:,t1+1) = 0.d0
            end if
            
        end do
    end if 
end do

do i1 = 1,H
    panel(i1,1,T) = i1
    panel(i1,8,T) = T
end do

do i1=1,H !savings and consumption in last period
    if (panel(i1,12,T)==1.d0) then !allive
        call find_pos(hgrid,panel(i1,13,T)+1.d0,aux_h,nh)
        aux_h = min(nh,aux_h)
        aux_h = max(1,aux_h)
        call lininter(grid_nc,w_r(:,retire),nc,panel(i1,4,T),wr_aux)
        call lininter(grid_nc,wgross_r(:,retire),nc,panel(i1,4,T),w_gt)
        costs(1) = costs(1)+(w_gt-wr_aux)
        call interp2(agrid,grid_nc,policy_a_r(:,:,aux_h,retire),na,nc &
            ,panel(i1,6,T),panel(i1,4,T),k_dec)
        call interp2(agrid,grid_nc,policy_h_r(:,:,aux_h,retire),na,nc &
            ,panel(i1,6,T),panel(i1,4,T),h_dec)
        call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
        aux_ht = min(nh,aux_ht)
        aux_ht = max(1,aux_ht)
        dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice        
        if (dist>10.d0) then
            call find_pos(agrid,panel(i1,6,T),a_temp,na)
            a_temp = max(a_temp,1)
            a_temp = min(a_temp,na)
            call interp2(agrid,grid_nc,policy_h_r(:,:,aux_h,retire),na,nc &
                ,agrid(a_temp),panel(i1,4,T),h_dec)
            call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
            aux_ht = min(nh,aux_ht)
            aux_ht = max(1,aux_ht)
            dist = abs(hgrid(aux_ht)-h_dec) !assure that h_dec is a discrete choice
            if (dist>10.d0) then
                call find_pos(grid_nc,panel(i1,4,T),nc_temp,nc)
                nc_temp = max(nc_temp,1)
                nc_temp = min(nc_temp,nc)
                h_dec = policy_h_r(a_temp,nc_temp,aux_h,retire)
                call find_pos(hgrid,h_dec+1.d0,aux_ht,nh)
                aux_ht = min(nh,aux_ht)
                aux_ht = max(1,aux_ht)
                k_dec = policy_a_r(a_temp,nc_temp,aux_h,retire)
            else
                call interp2(agrid,grid_nc,policy_a_r(:,:,aux_h,retire),na,nc &   
                    ,agrid(a_temp),panel(i1,4,T),k_dec)
            end if
        end if
        if (hgrid(aux_ht) /= panel(i1,13,T)) then !adjustment costs
            aux_xi = xi
        else
            aux_xi=0.d0
        end if
        call lininter(grid_nc,S_r(:,retire),nc,panel(i1,4,T),S_aux)

        if (w_gt<=ybarf_o(T)) then
            panel(i1,10,T) = 1.d0
            if (k_dec>abar(T) .and.  k_dec<(abar(T)+1000.d0)) then !possible extrapolation error
                call find_pos(grid_nc,panel(i1,4,T),nc_temp,nc)
                nc_temp = max(nc_temp,1)
                nc_temp = min(nc_temp,nc)
                call find_pos(agrid,panel(i1,6,T),a_temp,na)
                a_temp = max(a_temp,1)
                a_temp = min(a_temp,na)
                call interp2(agrid,grid_nc,policy_a_r(:,:,aux_h,retire),na,nc &
                    ,agrid(a_temp),grid_nc(nc_temp),k_dec2)
                if (k_dec2<(abar(T)+10.d0)) then
                    k_dec = abar(T)
                end if
            end if
        end if
        panel(i1,5,T) = wr_aux

        if (k_dec<=((abar(t1)+10.d0)) .AND. (w_gt<=ybarf_o(T))) then 
            call interp2(agrid,grid_nc,policy_s_r(:,:,aux_h,retire),na,nc &
                ,panel(i1,6,T),panel(i1,4,T),s_dec)
            if (s_dec<=0.5) then
                panel(i1,7,T) = R*panel(i1,6,T)+wr_aux-aux_xi &
                    +S_aux-k_dec-(hgrid(aux_ht)-panel(i1,13,T)) !consumption
                panel(i1,11,T) = S_aux
                costs(2) = costs(2)+S_aux
            else
                panel(i1,7,T) = R*panel(i1,6,T)+wr_aux-health(T)-aux_xi &
                    -k_dec-(hgrid(aux_ht)-panel(i1,13,T)) !consumption
            end if
        else
            panel(i1,7,T) = R*panel(i1,6,T)+wr_aux-health(T)-aux_xi &
                -k_dec-(hgrid(aux_ht)-panel(i1,13,T)) !consumption
        end if  

        count_b = count_b+1.d0
    end if
end do




end subroutine



subroutine cumsum(vec_in,vec_out,n)
!performs cumsum on vector vec_in

!define in and outputs
integer, intent(in)	   :: n
real(8), intent(in)    :: vec_in(n)
real(8), intent(out)   :: vec_out(n)
integer                :: i1

vec_out(1) = vec_in(1)
do i1 = 2,n
	vec_out(i1) = vec_out(i1-1)+vec_in(i1)
end do

end subroutine



subroutine find_pos(vec_in,sca,pos,n)
!finds sca on monotone vector vec_in (number of smaller/equal points)

!define in and outputs
integer, intent(in)	   :: n
real(8), intent(in)    :: vec_in(n),sca
integer, intent(out)   :: pos
integer                :: i1

pos = 0
do i1 = 1,n
	if (sca>=vec_in(i1)) then
		pos = i1
	end if
	if (vec_in(i1)>sca) exit
end do

end subroutine




subroutine lininter(x,y,n,x0,y0)

!Function lininter computes a linear interpolation for point x0
!given the vector of x-values in x and their corresponding funtional values y with length n

implicit none

!define in and outputs
integer, intent(in)						:: n
real(8), intent(in)             		:: x(n),y(n)
real(8), intent(in)                     :: x0
real(8), intent(out)                    :: y0

!further variables 
integer                                 :: j

!call locate(x,n,x0,j)
call find_pos(x,x0,j,n)
j = min(j,n-1)
j = max(1,j)

y0 = y(j)+(y(j+1)-y(j))*(x0-x(j))/(x(j+1)-x(j));

end subroutine lininter

    
    
subroutine interp2(x,y,v,nx,ny,x0,y0,v0)

!Function lininter computes a 2D linear interpolation for point x0,y0
!given the vector of x and y-values in x and y and their 
!corresponding funtional values v 

implicit none

!define in and outputs
integer(4), intent(in)                  :: nx,ny
real(8), intent(in)             		:: x(nx),y(ny),v(nx,ny)
real(8), intent(in)                     :: x0,y0
real(8), intent(out)                    :: v0

!further variables 
integer(4)                                 :: jx,jy,n
real(8)                                 :: num,a00,a01,a10,a11

!call locate(x,n,x0,j)
call find_pos(x,x0,jx,nx)

if (jx==0) then
    jx=1
elseif (jx==nx) then
    jx=nx-1
end if

call find_pos(y,y0,jy,ny)

if (jy==0) then
    jy=1
elseif (jy==ny) then
    jy=ny-1
end if


num = ((x(jx+1)-x(jx))*(y(jy+1)-y(jy)))
a00 = ((x(jx+1)-x0)*(y(jy+1)-y0))/num
a01 = ((x(jx+1)-x0)*(y0-y(jy)))/num
a10 = ((x0-x(jx))*(y(jy+1)-y0))/num
a11 = ((x0-x(jx))*(y0-y(jy)))/num

v0 = a00*v(jx,jy)+a01*v(jx,jy+1)+a10*v(jx+1,jy)+a11*v(jx+1,jy+1)

end subroutine interp2
    
subroutine interp3(x,y,z,v,nx,ny,nz,x0,y0,z0,v0)
!Function interp3 computes a 3D linear interpolation for point x0,y0,z0
!given the vector of x, y and z-values in x and y and their 
!corresponding funtional values v 

implicit none

!define in and outputs
integer(4), intent(in)                  :: nx,ny,nz
real(8), intent(in)             		:: x(nx),y(ny),z(nz),v(nx,ny,nz)
real(8), intent(in)                     :: x0,y0,z0
real(8), intent(out)                    :: v0

!further variables 
integer(4)                              :: jx,jy,jz,n
real(8)                                 :: num,a000,a001,a010,a011
real(8)                                 :: a100,a101,a110,a111



call find_pos(x,x0,jx,nx)

if (jx==0) then
    jx=1
elseif (jx==nx) then
    jx=nx-1
end if

call find_pos(y,y0,jy,ny)

if (jy==0) then
    jy=1
elseif (jy==ny) then
    jy=ny-1
end if


call find_pos(z,z0,jz,nz)

if (jz==0) then
    jz=1
elseif (jz==nz) then
    jz=nz-1
end if


num = ((x(jx+1)-x(jx))*(y(jy+1)-y(jy))*(z(jz+1)-z(jz)))

a000 = ((x(jx+1)-x0)*(y(jy+1)-y0)*(z(jz+1)-z0))/num
a001 = ((x(jx+1)-x0)*(y(jy+1)-y0)*(z0-z(jz)))/num
a010 = ((x(jx+1)-x0)*(y0-y(jy))*(z(jz+1)-z0))/num
a011 = ((x(jx+1)-x0)*(y0-y(jy))*(z0-z(jz)))/num
a100 = ((x0-x(jx))*(y(jy+1)-y0)*(z(jz+1)-z0))/num
a101 = ((x0-x(jx))*(y(jy+1)-y0)*(z0-z(jz)))/num
a110 = ((x0-x(jx))*(y0-y(jy))*(z(jz+1)-z0))/num
a111 = ((x0-x(jx))*(y0-y(jy))*(z0-z(jz)))/num


v0 = a000*v(jx,jy,jz)+a001*v(jx,jy,jz+1)+a010*v(jx,jy+1,jz)+a011*v(jx,jy+1,jz+1) &
        +a100*v(jx+1,jy,jz)+a101*v(jx+1,jy,jz+1)+a110*v(jx+1,jy+1,jz)+a111*v(jx+1,jy+1,jz+1)
        
end subroutine interp3
    
    
subroutine sub_mexWriteString(String)
  implicit none
  character(*),intent(in):: String
  call mexPrintf(achar(10))
  call mexPrintf(trim(adjustl(String)))
end subroutine sub_mexWriteString