
use "F:\Insurance\Revision\Numerics\Clean\Stata\cexdataweb", clear


keep if refage>24
drop if refage >= 65
drop if intyea>95
replace intyea=intyea+100

*replace nondur=nondur+enter
gen nondur50= nondur
gen lnondur = log(nondur)
recode refage (25/29=1) (30/34=2) (35/39=3) (40/44=4) (45/49=5) (50/54=6) (55/59=7) (60/64=8), gen(agegroup)

gen cohort=intyea-refage

collapse (sd) lnondur (p10) p10=nondur (p50) p50=nondur, by(refage cohort)
replace lnondur=lnondur^2
gen p5010 = p50/p10
reg lnondur i.refage i.cohort, nocons


mat beta=e(b)
svmat double beta
keep beta*
drop if beta1==.

local PATH "F:\Insurance\Revision\Numerics\Clean\Stata"

cd "`PATH'"
outsheet using ineqal_cons, comma nolabel nonames replace
