local PATH "F:\Insurance\Revision\Numerics\Clean\Stata"

cd "`PATH'"
use "F:\Insurance\Revision\Numerics\Clean\Stata\aggregated", clear

keep if age>24
drop if age >= 65


*recode
replace sex=0 if sex==1
replace race = 0 if race==1
replace hmetro = 0 if hmetro==1
replace ms = 0 if ms==1
replace educ = 0 if educ==4



gen means = hssi_inc+hotherw_inc+hafdc_inc+hfood_inc+hwic_inc
replace htot_inc = hh_lincome+means
drop if htot_inc<10
gen learn = log(htot_inc)
sum learn if age==25

*generate residuals
xi: reg learn i.age i.year i.sex i.race i.hmetro i.ms i.hstate [aweight=hwgt]
predict yhat
gen resid= learn-yhat

sum resid if age==25

*compute variance over age
sort id wave
gen m0 = resid*resid
gen cohort=year-age
collapse (sd) resid [aweight=hwgt], by(age cohort)
replace resid=resid^2

*regress on age and cohort dummies
reg resid i.age i.cohort, nocons

mat beta=e(b)
svmat double beta
keep beta*
drop if beta1==.
outsheet using ineqal_inc, comma nolabel nonames replace
