*directory

set mem 700m
local PATH "F:\Data\SIPP\Extracts"


cd "`PATH'"


use pp_id pp_entry pp_pnum id rot occ1* ind1* age* esr* clswk1* pubrnamt engry_y* engryam* sex race ethnicty disab att_sch* higrad* grd_cmp* geo_st* ms* pp_ear* hh_inc* hh_ear* hh_pro* hh_tra* hh_oth* pp_mis* hh_add* using sipp91lfp1, clear

rename pp_id suid
rename pp_entry entry
rename pp_pnum pnum

destring entry, replace
destring pnum, replace

renpfix age_ age
renpfix age0 age
renpfix ms_ ms
renpfix ms0 ms
renpfix esr_ esr
renpfix esr0 esr
renpfix clswk10 class1
renpfix clswk class
renpfix occ1_0 occ31
renpfix occ1_ occ31
renpfix ind1_0 ind31
renpfix ind1_ ind31
renpfix hh_add0 hh_add
renpfix pp_mis0 pp_mis
renpfix pp_ear0 pp_ear
renpfix hh_inc0 hh_inc
renpfix hh_ear0 hh_ear
renpfix hh_pro0 hh_pro
renpfix hh_tra0 hh_tra
renpfix hh_oth0 hh_oth


*make quarterly variables monthly
forval j=1/4 {
gen enrgy_r`j' = engry_y1
gen enrgy_a`j' = engryam1
gen grade`j' = higrade1
gen grdcmpl`j' = grd_cmp1
gen enrold`j' = att_sch1
gen hstate`j' = geo_ste1
}
forval j=5/8 {
gen enrgy_r`j' = engry_y2
gen enrgy_a`j' = engryam2
gen grade`j' = higrade2
gen grdcmpl`j' = grd_cmp2
gen enrold`j' = att_sch2
gen hstate`j' = geo_ste2
}
forval j=9/12 {
gen enrgy_r`j' = engry_y3
gen enrgy_a`j' = engryam3
gen grade`j' = higrade3
gen grdcmpl`j' = grd_cmp3
gen enrold`j' = att_sch3
gen hstate`j' = geo_ste3
}
forval j=13/16 {
gen enrgy_r`j' = engry_y4
gen enrgy_a`j' = engryam4
gen grade`j' = higrade4
gen grdcmpl`j' = grd_cmp4
gen enrold`j' = att_sch4
gen hstate`j' = geo_ste4
}
forval j=17/20 {
gen enrgy_r`j' = engry_y5
gen enrgy_a`j' = engryam5
gen grade`j' = higrade5
gen grdcmpl`j' = grd_cmp5
gen enrold`j' = att_sch5
gen hstate`j' = geo_ste5
}
forval j=21/24 {
gen enrgy_r`j' = engry_y6
gen enrgy_a`j' = engryam6
gen grade`j' = higrade6
gen grdcmpl`j' = grd_cmp6
gen enrold`j' = att_sch6
gen hstate`j' = geo_ste6
}
forval j=25/28 {
gen enrgy_r`j' = engry_y7
gen enrgy_a`j' = engryam7
gen grade`j' = higrade7
gen grdcmpl`j' = grd_cmp7
gen enrold`j' = att_sch7
gen hstate`j' = geo_ste7
}
forval j=29/32 {
gen enrgy_r`j' = engry_y8
gen enrgy_a`j' = engryam8
gen grade`j' = higrade8
gen grdcmpl`j' = grd_cmp8
gen enrold`j' = att_sch8
gen hstate`j' = geo_ste8
}
drop engryam* engry_y* higrade* grd_cmp* att_sch* geo_ste*

reshape long occ31 ind31 class1 age esr enrgy_r enrgy_a grade grdcmpl enrold hstate ms pp_ear hh_inc hh_ear hh_pro hh_tra hh_oth pp_mis hh_add, i(id) j(mnth)
rename hh_add addid
gen month2 = mnth
do "F:\Data\SIPP\Do Files\monthwave91.do"
sort id wave month
save "F:\Data\SIPP\Temp\testm1", replace


use id rot se_am* using sipp91lfp2, clear

renpfix se_am10 se_am1
renpfix se_am20 se_am2
renpfix se_am selfinc

reshape long selfinc1 selfinc2, i(id) j(mnth)
gen month2 = mnth
        
do "F:\Data\SIPP\Do Files\monthwave91.do"      
sort id wave month
merge id wave month using "F:\Data\SIPP\Temp\testm1"
tab _merge
drop _merge
sort suid entry pnum wave month
save "F:\Insurance\Stata\91_fp", replace



/***********************************************************
Core data files (are now long, not wide)
**********************************************************/

use sipp91w1, clear



#delimit ;
keep (suid entry pnum addid hrefper pnum panel wave month year 
hnp hwgt hmetro hmeans hpov hnoncsh hsocsec hssi hunemp hafdc hfdstp eastamt wicval
totinc prop tran other
inaf empled retird 
s01amta s01amtk s02amta s02amtk s03amt s05amt s06amt s07amt s08amt s10amt s12amt s13amt
s20amt s21amt s23amt s24amt s27amt s28amt s29amt s30amt s31amt s32amt s34amt s35amt s36amt s37amt s38amt
s40amt s41amt s50amt s51amt s52amt s53amt s54amt s55amt s56amt s75amt
disage socsr1 socsr2)
;
#delimit cr

*create person number in same format as reference person
destring entry, replace
destring pnum,replace
sort suid addid wave

sort suid addid wave


save "F:\Insurance\Stata\91_1", replace
clear


use sipp91w2, clear

#delimit ;
keep (suid entry pnum addid hrefper pnum panel wave month year 
hnp hwgt hmetro hmeans hpov hother hnoncsh hsocsec hssi hunemp hafdc hfdstp eastamt wicval
totinc prop tran other
inaf empled retird 
s01amta s01amtk s02amta s02amtk s03amt s05amt s06amt s07amt s08amt s10amt s12amt s13amt
s20amt s21amt s23amt s24amt s27amt s28amt s29amt s30amt s31amt s32amt s34amt s35amt s36amt s37amt s38amt
s40amt s41amt s50amt s51amt s52amt s53amt s54amt s55amt s56amt s75amt
disage socsr1 socsr2)
;
#delimit cr

*create person number in same format as reference person
destring entry, replace
destring pnum,replace
sort suid addid wave

sort suid addid wave


save "F:\Insurance\Stata\91_2", replace
clear



use sipp91w3, clear

#delimit ;
keep (suid entry pnum addid hrefper pnum panel wave month year 
hnp hwgt hmetro hmeans hpov hother hnoncsh hsocsec hssi hunemp hafdc hfdstp eastamt wicval
totinc prop tran other
inaf empled retird 
s01amta s01amtk s02amta s02amtk s03amt s05amt s06amt s07amt s08amt s10amt s12amt s13amt
s20amt s21amt s23amt s24amt s27amt s28amt s29amt s30amt s31amt s32amt s34amt s35amt s36amt s37amt s38amt
s40amt s41amt s50amt s51amt s52amt s53amt s54amt s55amt s56amt s75amt
disage socsr1 socsr2)
;
#delimit cr

*create person number in same format as reference person
destring entry, replace
destring pnum,replace
sort suid addid wave

sort suid addid wave


save "F:\Insurance\Stata\91_3", replace

clear



*medical expenditure
use sipp91t4, clear
rename id suid

rename tm8410 medi_exp
#delimit ;
keep (suid entry pnum medi_exp)
;
#delimit cr
sort suid entry pnum

save "F:\Insurance\Stata\91_t4", replace

use sipp91w4, clear
sort suid entry pnum
merge suid entry pnum using "F:\Insurance\Stata\91_t4.dta"
drop if _merge==2
drop _merge

#delimit ;
keep (suid entry pnum addid hrefper pnum panel wave month year 
hnp hwgt hmetro hmeans hpov hother hnoncsh hsocsec hssi hunemp hafdc hfdstp eastamt wicval
totinc prop tran other
inaf empled retird 
s01amta s01amtk s02amta s02amtk s03amt s05amt s06amt s07amt s08amt s10amt s12amt s13amt
s20amt s21amt s23amt s24amt s27amt s28amt s29amt s30amt s31amt s32amt s34amt s35amt s36amt s37amt s38amt
s40amt s41amt s50amt s51amt s52amt s53amt s54amt s55amt s56amt s75amt
disage socsr1 socsr2
medi_exp refmth)
;
#delimit cr

replace medi_exp=. if refmth!=4
drop refmth

*create person number in same format as reference person
destring entry, replace
destring pnum,replace
sort suid addid wave

sort suid addid wave


save "F:\Insurance\Stata\91_4", replace
clear



use sipp91w5, clear

#delimit ;
keep (suid entry pnum addid hrefper pnum panel wave month year 
hnp hwgt hmetro hmeans hpov hother hnoncsh hsocsec hssi hunemp hafdc hfdstp eastamt wicval
totinc prop tran other
inaf empled retird 
s01amta s01amtk s02amta s02amtk s03amt s05amt s06amt s07amt s08amt s10amt s12amt s13amt
s20amt s21amt s23amt s24amt s27amt s28amt s29amt s30amt s31amt s32amt s34amt s35amt s36amt s37amt s38amt
s40amt s41amt s50amt s51amt s52amt s53amt s54amt s55amt s56amt s75amt
disage socsr1 socsr2)
;
#delimit cr

*create person number in same format as reference person
destring entry, replace
destring pnum,replace
sort suid addid wave

sort suid addid wave


save "F:\Insurance\Stata\91_5", replace
clear





use sipp91w6, clear

#delimit ;
keep (suid entry pnum addid hrefper pnum panel wave month year 
hnp hwgt hmetro hmeans hpov hother hnoncsh hsocsec hssi hunemp hafdc hfdstp eastamt wicval
totinc prop tran other
inaf empled retird 
s01amta s01amtk s02amta s02amtk s03amt s05amt s06amt s07amt s08amt s10amt s12amt s13amt
s20amt s21amt s23amt s24amt s27amt s28amt s29amt s30amt s31amt s32amt s34amt s35amt s36amt s37amt s38amt
s40amt s41amt s50amt s51amt s52amt s53amt s54amt s55amt s56amt s75amt
disage socsr1 socsr2)
;
#delimit cr

*create person number in same format as reference person
destring entry, replace
destring pnum,replace
sort suid addid wave

sort suid addid wave


save "F:\Insurance\Stata\91_6", replace
clear



*assets
use sipp91t7, clear
rename id suid


#delimit ;
keep (suid entry pnum addid hh_vehcl hh_intbk hh_intot hh_stk hh_ore hh_otast hh_ira hh_theq hh_beq hh_usdbt)
;
#delimit cr
sort suid entry pnum

save "F:\Insurance\Stata\91_t7", replace



use sipp91w7, clear
sort suid entry pnum
merge suid entry pnum using "F:\Insurance\Stata\91_t7.dta"
drop if _merge==2
drop _merge

#delimit ;
keep (suid entry pnum addid hrefper pnum panel wave month year 
hnp hwgt hmetro hmeans hpov hother hnoncsh hsocsec hssi hunemp hafdc hfdstp eastamt wicval
totinc prop tran other
inaf empled retird 
s01amta s01amtk s02amta s02amtk s03amt s05amt s06amt s07amt s08amt s10amt s12amt s13amt
s20amt s21amt s23amt s24amt s27amt s28amt s29amt s30amt s31amt s32amt s34amt s35amt s36amt s37amt s38amt
s40amt s41amt s50amt s51amt s52amt s53amt s54amt s55amt s56amt s75amt
disage socsr1 socsr2
hh_vehcl hh_intbk hh_intot hh_stk hh_ore hh_otast hh_ira hh_theq hh_beq hh_usdbt refmth)
;
#delimit cr

replace hh_vehcl=. if refmth!=4
replace hh_intbk=. if refmth!=4
replace hh_intot=. if refmth!=4
replace hh_stk=. if refmth!=4
replace hh_ore=. if refmth!=4
replace hh_otast=. if refmth!=4
replace hh_ira=. if refmth!=4
replace hh_theq=. if refmth!=4
replace hh_beq=. if refmth!=4
replace hh_usdbt=. if refmth!=4

drop refmth

*create person number in same format as reference person
destring entry, replace
destring pnum,replace
sort suid addid wave

sort suid addid wave


save "F:\Insurance\Stata\91_7", replace
clear




use sipp91w8, clear

#delimit ;
keep (suid entry pnum addid hrefper pnum panel wave month year 
hnp hwgt hmetro hmeans hpov hother hnoncsh hsocsec hssi hunemp hafdc hfdstp eastamt wicval
totinc prop tran other
inaf empled retird 
s01amta s01amtk s02amta s02amtk s03amt s05amt s06amt s07amt s08amt s10amt s12amt s13amt
s20amt s21amt s23amt s24amt s27amt s28amt s29amt s30amt s31amt s32amt s34amt s35amt s36amt s37amt s38amt
s40amt s41amt s50amt s51amt s52amt s53amt s54amt s55amt s56amt s75amt
disage socsr1 socsr2)
;
#delimit cr

*create person number in same format as reference person
destring entry, replace
destring pnum,replace
sort suid addid wave

sort suid addid wave


save "F:\Insurance\Stata\91_8", replace
clear


/***********************************************************
*merge monthly data (should be no matches)
**********************************************************/
use "F:\Insurance\Stata\91_1.dta", clear
quiet merge suid addid wave using "F:\Insurance\Stata\91_2.dta"
tab _merge
drop _merge
sort suid addid wave
quiet merge suid addid wave using "F:\Insurance\Stata\91_3.dta"
tab _merge
drop _merge
sort suid addid wave
quiet merge suid addid wave using "F:\Insurance\Stata\91_4.dta"
tab _merge
drop _merge
sort suid addid wave
quiet merge suid addid wave using "F:\Insurance\Stata\91_5.dta"
tab _merge
drop _merge
sort suid addid wave
quiet merge suid addid wave using "F:\Insurance\Stata\91_6.dta"
tab _merge
drop _merge
sort suid addid wave
quiet merge suid addid wave using "F:\Insurance\Stata\91_7.dta"
tab _merge
drop _merge
sort suid addid wave
quiet merge suid addid wave using "F:\Insurance\Stata\91_8.dta"
tab _merge
drop _merge

sort suid entry pnum wave month
quiet merge suid entry pnum wave month using "F:\Insurance\Stata\91_fp.dta"
drop if _merge==2
drop _merge
keep if pp_mis==1 
drop pp_mis

replace pnum = entry*1000+pnum

rename grdcmpl grd_cmp

*clean reason for sose and ever disabled and retired
drop id
egen id = group(suid entry pnum)
sort id
by id: egen aux = max(socsr1)
replace socsr1=aux if socsr1==0
drop aux
by id: egen aux = max(socsr2)
replace socsr2=aux if socsr2==0
drop aux
by id: egen aux = max(disage)
replace disage=aux if disage==0
drop aux
replace retird=0 if retird==2
by id: egen aux = max(retird)
replace retird=aux if retird==0
drop aux

replace wicval = wicval/100
replace enrgy_a = enrgy_a/4

*topcoded earnings
rename pp_ear earn
gen  earn_tc = earn>=8333 
local T=8333
qui sum earn_tc
local F2=r(mean)
_pctile earn if earn!=0, p(80)
local y8=r(r1)
local alpha8=ln((1-0.8)/(`F2'))/ln(`T'/`y8')
gen check=`T'/((1-runiform())^(1/`alpha8')) if earn_tc==1
replace earn=check if earn_tc==1
cap drop check earn_tc

*topcoded housing wealth (vehicle not topcoded)
gen  hh_theq_tc = 0
replace  hh_theq_tc = 1 if hh_theq>=310000 & hh_theq~=.
local T=310000
qui sum hh_theq_tc if hh_theq~=.
local F2=r(mean)
_pctile hh_theq if hh_theq!=., p(90)
local y8=r(r1)
local alpha8=ln((1-0.9)/(`F2'))/ln(`T'/`y8')
gen check=`T'/((1-runiform())^(1/`alpha8')) if hh_theq_tc==1
replace hh_theq=check if hh_theq_tc==1
cap drop check hh_theq_tc


*topcoded banking wealth (hh_intot almost no observations)
gen  hh_intbk_tc = 0
replace  hh_intbk_tc = 1 if hh_intbk>=10000000 & hh_intbk~=. 
local T=10000000
qui sum hh_intbk_tc if hh_intbk~=.
local F2=r(mean)
_pctile hh_intbk if hh_intbk!=., p(95)
local y8=r(r1)
local alpha8=ln((1-0.95)/(`F2'))/ln(`T'/`y8')
gen check=`T'/((1-runiform())^(1/`alpha8')) if hh_intbk_tc==1
replace hh_intbk=check if hh_intbk_tc==1
cap drop check hh_intbk_tc


*topcoded stock wealth (hh_ore almost no observations)
gen  hh_stk_tc = 0
replace  hh_stk_tc = 1 if hh_stk>=1999998 & hh_stk~=.
local T=1999998
qui sum hh_stk_tc if hh_stk~=.
local F2=r(mean)
_pctile hh_intbk if hh_intbk!=., p(95)
local y8=r(r1)
local alpha8=ln((1-0.95)/(`F2'))/ln(`T'/`y8')
gen check=`T'/((1-runiform())^(1/`alpha8')) if hh_stk_tc==1
replace hh_stk=check if hh_stk_tc==1
cap drop check hh_stk_tc


*topcoded IRA
gen  hh_ira_tc = 0
replace  hh_ira_tc = 1 if hh_ira>=375000 & hh_ira~=.
local T=375000
qui sum hh_ira_tc if hh_ira~=.
local F2=r(mean)
_pctile hh_ira if hh_ira!=., p(95)
local y8=r(r1)
local alpha8=ln((1-0.95)/(`F2'))/ln(`T'/`y8')
gen check=`T'/((1-runiform())^(1/`alpha8')) if hh_ira_tc==1
replace hh_ira=check if hh_ira_tc==1
cap drop check hh_ira_tc

*unsecured debt
gen  hh_usdbt_tc = 0
replace  hh_usdbt_tc = 1 if hh_usdbt>=1000000 & hh_usdbt~=.
local T=1000000
qui sum hh_usdbt_tc if hh_usdbt~=.
local F2=r(mean)
_pctile hh_usdbt if hh_usdbt!=., p(95)
local y8=r(r1)
local alpha8=ln((1-0.95)/(`F2'))/ln(`T'/`y8')
gen check=`T'/((1-runiform())^(1/`alpha8')) if hh_usdbt_tc==1
replace hh_usdbt=check if hh_usdbt_tc==1
cap drop check hh_usdbt_tc


*retirement income (social security/railroad+other/pension)
gen sose_inc = s01amta+s01amtk
gen ret_inc = s02amta+s02amtk+s38amt
gen pension_p_inc = s30amt
gen pension_g_inc = s31amt+s32amt+s34amt+s35amt
*unemployment income
gen unemp_inc = s05amt+s06amt+s07amt
*other income (private disability and sickness+child support+alimony+veteran+gift+other+life insurance+trusts+Foster)
gen other_inc = s13amt+s28amt+s29amt+s40amt+s41amt+s50amt+s51amt+s52amt+s53amt+s54amt+s56amt+s75amt+s36amt+s37amt+s23amt
*porperty income (life insurance+trusts
gen prop_inc = prop
*earnings (including sickness pay+causal earnings)
replace earn = earn+s10amt+s12amt+s55amt
*suplemental security income+veteran pension
gen ssi_inc = s03amt+s08amt
* afdc income+general relief
gen afdc = s20amt+s21amt
*other+foster+energy
gen oth_welfare = s24amt+enrgy_a
gen food = s27amt
gen wic = wicval

drop s01amta s01amtk s02amta s02amtk s03amt s05amt s06amt s07amt s08amt s10amt s12amt s20amt s21amt s23amt s24amt s27amt s28amt s29amt s30amt s31amt s32amt s34amt s35amt s36amt s37amt s38amt s40amt s41amt s50amt s51amt s52amt s53amt s54amt s55amt s56amt s75amt wicval eastamt 
drop id
sort suid addid panel

save "F:\Insurance\Revision\Numerics\Clean\Stata\91_panel.dta", replace
clear
